SystemOrganization addCategory: #'NECompletion-Model'!
SystemOrganization addCategory: #'NECompletion-Pharo'!
SystemOrganization addCategory: #'NECompletion-Tests'!
SystemOrganization addCategory: #'NECompletion-View'!

!CodeHolder methodsFor: '*necompletion-override' stamp: 'EstebanLorenzano 4/11/2012 17:11'!
contentsChanged
	super contentsChanged.
	self changed: #annotation.! !

Morph subclass: #NECDetailMorph
	instanceVariableNames: 'title description arrowPosition label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-View'!

!NECDetailMorph commentStamp: '<historical>' prior: 0!
I display some detail information for a selected ECEntry in the ECMenuMorph.
The content I show, is provided by an ECDetailContentProvider subclass. 
!

!NECDetailMorph class methodsFor: 'as yet unclassified' stamp: ''!
height
	^ NECMenuMorph itemHeight * 15.5! !

!NECDetailMorph class methodsFor: 'as yet unclassified' stamp: ''!
width
	^ NECMenuMorph itemWidth * 2.0! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
bounds
	^ super bounds topLeft extent: self class width @ self class height! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
contentBounds
	| factor rectangle |
	factor := self itemHeight.
	rectangle := self bounds top: self bounds top + 3.
	rectangle := rectangle left: rectangle left + (factor * 2.0).
	rectangle := rectangle bottom: rectangle bottom - factor.
	^ rectangle! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
defaultColor
	^ NECMenuMorph backgroundColor. ! !

!NECDetailMorph methodsFor: 'accessing' stamp: ''!
descriptionBounds
	^ self contentBounds top: self contentBounds top + 30! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
drawArrowOn: aCanvas
	| point factor poligon |
	factor := self itemHeight.
	point := arrowPosition.
	poligon := OrderedCollection new.
	poligon add: point.
	poligon add: (point := point translateBy: (factor / 2) @ 0).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: factor @ factor).
	poligon add: (point := point translateBy: (factor * -1) @ factor).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: (factor * -0.5) @ 0).
	aCanvas drawPolygon: poligon fillStyle: self scrollColor! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
drawMessageOn: aCanvas
	| factor rectangle width browseMessage |
	factor := self itemHeight.
	rectangle := self bounds top: self bounds bottom - factor.
	rectangle := rectangle left: self contentBounds left.
	aCanvas line: rectangle topLeft + (0 @ 2) to: rectangle topRight + (-3 @ 2) color: Color darkGray.
	rectangle := rectangle top: rectangle top + 3.
	aCanvas
		drawString: '<- close detail'
		in: rectangle
		font: self messageFont
		color: Color darkGray.
	browseMessage := 'browse ->'.
	width := self messageFont widthOfString: browseMessage.
	aCanvas
		drawString: browseMessage
		in: (rectangle left: rectangle right - width)
		font: self messageFont
		color: Color darkGray! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	super drawOn: aCanvas.
	arrowPosition ifNotNil: [
	self drawArrowOn: aCanvas.
	self drawMessageOn: aCanvas]! !

!NECDetailMorph methodsFor: 'accessing' stamp: ''!
entryDescription: anECEntryDescription 
	| categoryContents entryDescription |
	entryDescription := anECEntryDescription.
	title
		contents: (entryDescription title
				ifNil: [description bounds: self titleBounds.
					String new]
				ifNotNil: [description bounds: self descriptionBounds.
					entryDescription title]).
	description contentsWrapped: entryDescription description.
	categoryContents := entryDescription label.
	label contents: categoryContents! !

!NECDetailMorph methodsFor: 'accessing' stamp: ''!
initialize
	| childBounds |
	super initialize.
	childBounds := self contentBounds.
	label := StringMorph 
		contents: ''
		font: self messageFont.
	label bounds: childBounds.
	self addMorph: label.
	title := StringMorph 
		contents: ''
		font: NECMenuMorph titleFont.
	title bounds: self titleBounds.
	self addMorph: title.
	description := TextMorph new.
	description autoFit: false.
	description bounds: self descriptionBounds.
	description borderWidth: 0.
	self addMorph: description! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
itemHeight
	^ NECMenuMorph itemHeight! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
messageFont
	^ NECMenuMorph messageFont! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
position: aPoint menuWidth: anInteger 
	| y x |
	arrowPosition := aPoint.
	y := aPoint y + self class height.
	y := y > Display height
				ifTrue: [Display height - self class height]
				ifFalse: [aPoint y - self itemHeight].
	x := aPoint x.
	x := x + self class width > Display width
				ifTrue: [arrowPosition := (self positionOnLeft: anInteger) @ aPoint y.
					arrowPosition x]
				ifFalse: [x].
	self position: x @ y! !

!NECDetailMorph methodsFor: 'private' stamp: ''!
positionOnLeft: anInteger 
	^ arrowPosition x - self class width - anInteger ! !

!NECDetailMorph methodsFor: 'drawing' stamp: ''!
scrollColor
	^ NECMenuMorph scrollColor! !

!NECDetailMorph methodsFor: 'accessing' stamp: ''!
titleBounds
	^ self contentBounds top: self contentBounds top + 10! !

Morph subclass: #NECMenuMorph
	instanceVariableNames: 'selected firstVisible titleStringMorph controller context pageHeight detailMorph detailPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-View'!

!NECMenuMorph commentStamp: '<historical>' prior: 0!
I show the possible completions in a menu like appearance. The user may choose an entry from my list and complete the word he was typing in the editor. I'm showed with the Tab key and will be deleted when with ESC key or when a successful completion occurs. The following keystrokes are supported:

Ctrl-Space or Tab: Open a new morph. Tab requires at least one character in front of the cursor. When already open complete the selected entry. 
Esc: Close me
Ctrl+u: Change to untyped mode, so I show all selectors of all classes in the system and the variables that are accessible to the current context.
Arrow Up: Move one entry up.
Arrow Down: Move one entry down
Enter: (like Ctrl-Space and Tab): Complete with the selected item and close the morph
any letter or digit: Narrow the completion further
Ctrl+t: Toggle the expand flag. When expand is disabled, you don't see selectors belonging to Object and ProtoObject. 

!

!NECMenuMorph class methodsFor: 'preferences-colors' stamp: 'EstebanLorenzano 4/12/2012 13:37'!
backgroundColor
	^NECPreferences backgroundColor alpha: 0.8! !

!NECMenuMorph class methodsFor: 'instance creation' stamp: ''!
controller: aECController position: aPoint 
	| newObject |
	newObject := self new.
	newObject setController: aECController position: aPoint.
	^ newObject! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
convertToSHSymbol: aSymbol
	^ (SHTextStylerST80 new attributesFor: aSymbol) notNil
		ifTrue: [ aSymbol ]
		ifFalse: [ #default ]! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
itemHeight
	^ (self selectFontFor: #default) height + 2! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
itemWidth
	^ 250! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
maxLength
	^ 20! !

!NECMenuMorph class methodsFor: 'preferences-fonts' stamp: ''!
messageFont
	^ StandardFonts codeFont! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
scrollArrowSize
	^ 8! !

!NECMenuMorph class methodsFor: 'preferences-colors' stamp: ''!
scrollColor
	^ UITheme current settings selectionColor! !

!NECMenuMorph class methodsFor: 'preferences' stamp: ''!
selectColorFor: aSymbol 
	| attribute |
	attribute := self convertToSHSymbol: aSymbol.
	^ (SHTextStylerST80 new attributesFor: attribute) first color! !

!NECMenuMorph class methodsFor: 'preferences-fonts' stamp: ''!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new 
		attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1 
		ifTrue: [ attributes second emphasisCode ]
		ifFalse: [ 0 ].
	^ StandardFonts menuFont
		emphasized: emphasized! !

!NECMenuMorph class methodsFor: 'preferences-fonts' stamp: ''!
titleFont
	^ StandardFonts windowTitleFont! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
browse
	(self selectedEntry browseWith: context)
		ifTrue: [controller closeMenu]! !

!NECMenuMorph methodsFor: 'initialization' stamp: ''!
createTitle
	| titleString transformationMorph |
	titleString := context model title ifNil: [ ^ self ].
	
	titleStringMorph := StringMorph new.
	titleStringMorph font: self class titleFont.
	titleStringMorph contents: titleString.
	
	transformationMorph := TransformationMorph new.
	transformationMorph rotationDegrees: -90.0.
	transformationMorph offset: 0 @ titleStringMorph width negated.
	transformationMorph addMorph: titleStringMorph.

	self addMorph: transformationMorph! !

!NECMenuMorph methodsFor: 'paging' stamp: ''!
currentPage
	^(self selected - 1 // self pageHeight ) + 1.! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
delete
	super delete.
	controller menuClosed! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
detailMessage
	^ detailMorph
		ifNil: ['ctrl-h=help | -> open detail']
		ifNotNil: ['ctrl-h=help | <- close detail']! !

!NECMenuMorph methodsFor: 'accessing' stamp: ''!
detailPosition: aPoint 
	detailPosition := aPoint.
	self triggerEvent: #positionChanged! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawBottomScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	point := self bounds bottomLeft translateBy: 6 @ -12.
	arrowHeight := self class scrollArrowSize.
	aPoligon := Array 
		with: point
		with: (point translateBy: arrowHeight @ 0)
		with: (point translateBy: (arrowHeight / 2) @ arrowHeight).
	aCanvas 
		drawPolygon: aPoligon
		fillStyle: self class scrollColor! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawMessageOn: aCanvas in: rectangle 
	self hasMessage ifFalse: [ ^ self ].
	context model isEmpty ifFalse: 
		[ aCanvas 
			line: rectangle topLeft + (0 @ 2)
			to: rectangle topRight + (-3 @ 2)
			color: Color darkGray ].
	self 
		drawModelMessageOn: aCanvas
		in: rectangle.
	self 
		drawPageCountMessageOn: aCanvas
		in: rectangle! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawModelMessageOn: aCanvas in: rectangle 
	| message |
	message := context model hasMessage 
		ifTrue: [ context model message , ' | ctrl-h=help' ]
		ifFalse: [ self detailMessage ].
	aCanvas 
		drawString: message
		in: (rectangle insetBy: 3)
		font: self class messageFont
		color: Color darkGray! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| rectangle model |
	super drawOn: aCanvas.
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + self class itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	model := context model.
	self extent: self extent.
	self firstVisible > 1 ifTrue: [ self drawTopScrollArrowOn: aCanvas ].
	self lastVisible ~= self itemsCount ifTrue: [ self drawBottomScrollArrowOn: aCanvas ].
	model notEmpty ifTrue: 
		[ self firstVisible 
			to: self lastVisible
			do: 
				[ :index | 
				| symbol type string |
				symbol := model entries at: index.
				string := symbol contents.
				type := symbol type.
				index = self selected ifTrue: 
					[ | rect |
					rect := rectangle withBottom: rectangle top + self class itemHeight.
					aCanvas 
						fillRectangle: rect
						color: self class scrollColor.
					self detailPosition: rect topRight ].
				aCanvas 
					drawString: string
					in: (rectangle insetBy: 1)
					font: (self selectFont: type)
					color: (self selectColor: type).
				rectangle := self prepareRectForNextRow: rectangle ] ].
	self 
		drawMessageOn: aCanvas
		in: rectangle! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawPageCountMessageOn: aCanvas in: rectangle 
	| msg font msgWidth |
	self pageCount > 1 ifFalse: [ ^ self ].
	msg := self currentPage printString , '/' , self pageCountString.
	font := self class messageFont.
	msgWidth := font widthOfString: msg.
	aCanvas 
		drawString: msg
		in: (rectangle translateBy: (rectangle width - msgWidth - 3) @ 3)
		font: font
		color: Color darkGray! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
drawTopScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	arrowHeight := self class scrollArrowSize.
	point := self bounds topLeft translateBy: 6 @ 11.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight negated).
	aCanvas 
		drawPolygon: aPoligon 
		fillStyle: self class scrollColor. 
	! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
end
	self gotoPage: self pageCount.
	self changed.! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
expand
	context model toggleExpand.
	self narrowCompletion! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
firstVisible
	^firstVisible min: context model entryCount! !

!NECMenuMorph methodsFor: 'paging' stamp: ''!
gotoPage: anInteger
	| item |
	item := (anInteger - 1) * self pageHeight + 1.
	item >= self itemsCount
		ifTrue: [ ^ self ].
	item := item max: 1.
	firstVisible := item.
	self selected: firstVisible! !

!NECMenuMorph methodsFor: 'event handling' stamp: ''!
handleMouseEnter: anEvent
	self activeHand newKeyboardFocus: controller editor morph.
	anEvent wasHandled: true. 
! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
hasMessage
	^ true ! !

!NECMenuMorph methodsFor: 'accessing' stamp: ''!
height
	| count |
	count := self class maxLength.
	self visible ifTrue: [ 
		| height |
		height := World height - self bounds topLeft y.
		World submorphs do: [ :each |
			each class = TaskbarMorph 
				ifTrue: [ height := height - each height ] ].
		count := height // self class itemHeight - 1 min: count ].
	^ count asInteger isZero 
		ifTrue: [ 1 ]
		ifFalse: [ count ]! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
help
	NECHelpMorph new openInWorld! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
hideDetail
	detailMorph ifNil: [ ^ self ].
	self removeMorph: detailMorph.
	detailMorph delete.
	detailMorph := nil.
	self changed! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
home
	self gotoPage: 1.
	self changed! !

!NECMenuMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self color: self class backgroundColor.
	self on: #mouseDown send: #delete to: self.
	self
		when: #positionChanged
		send: #updateDetail
		to: self! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
insertCompletion: aString 
	| caret old pos editor |
	editor := controller editor.
	caret := editor caret.
	editor selectInvisiblyFrom: caret - context completionToken size to: caret - 1.
	old := editor selection. 
	editor zapSelectionWith: aString.
	pos := caret + (aString copyUpTo: $ ) size + 1 - old size.
	editor selectAt: pos.
	editor morph invalidRect: editor morph bounds! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
insertSelected
	context model isEmpty ifTrue: [^ false].
	self insertCompletion: (context model completionAt: self selected).
	self delete.
	^ true! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
isClosed
	^ owner isNil! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
itemsCount
	^context model entryCount! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
lastVisible

	^ (self firstVisible + self height-1)  min: (self itemsCount).! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
moveDown
	self selected: self selected + 1.
	(self selected > self lastVisible
			and: [self selected <= self itemsCount])
		ifTrue: [firstVisible := firstVisible + 1].
	self changed! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
moveUp
	(self selected = 0
			and: [self firstVisible = 1])
		ifTrue: [^ self].
	self selected: self selected - 1.
	self selected < self firstVisible
		ifTrue: [firstVisible := firstVisible - 1].
	self changed. ! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
narrowCompletion
	| model |
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	(model entries size = 1 and: [ context completionToken notEmpty ]) ifTrue: 
		[ self insertCompletion: (model completionAt: 1).
		self delete.
		^ false ].
	model notEmpty ifTrue: [ self selected: 1 ].
	self show.
	^ true! !

!NECMenuMorph methodsFor: 'paging' stamp: ''!
pageCount
	| count |
	self itemsCount == self pageHeight
		ifTrue: [^ 1].
	count := self itemsCount // self pageHeight.
	(self itemsCount \\ self pageHeight) > 0 
		ifTrue:[count := count + 1].
	^count! !

!NECMenuMorph methodsFor: 'paging' stamp: ''!
pageCountString
	^ self itemsCount = 501
		ifTrue: [ 'more' ]
		ifFalse: [ self pageCount asString ]! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
pageDown
	self gotoPage: self currentPage + 1.
	self changed. ! !

!NECMenuMorph methodsFor: 'paging' stamp: ''!
pageHeight
	^pageHeight.! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
pageUp
	self gotoPage: self currentPage - 1.
	self changed. ! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
prepareRectForNextRow: aRectangle 
	^aRectangle translateBy: 0 @ self class itemHeight! !

!NECMenuMorph methodsFor: 'title' stamp: ''!
removeTitle
	titleStringMorph
		ifNil: [^ self].
	self removeMorph: titleStringMorph owner. 
	titleStringMorph := nil! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
selectColor: type
	^ self class selectColorFor: type! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
selectFont: aSymbol 
	^ self class selectFontFor: aSymbol! !

!NECMenuMorph methodsFor: 'accessing' stamp: ''!
selected
	"Answer the value of selected"
	selected ifNil: [ selected := self firstVisible ].
	^ selected! !

!NECMenuMorph methodsFor: 'accessing' stamp: ''!
selected: aNumber 
	"Set the value of selected"
	context model notEmpty ifTrue: 
		[ ((1 to: self itemsCount) includes: aNumber) ifTrue: [ aNumber ~= selected ifTrue: [ selected := aNumber ] ] ]! !

!NECMenuMorph methodsFor: 'accessing' stamp: ''!
selectedEntry
	^ context model entries at: self selected! !

!NECMenuMorph methodsFor: 'initialization' stamp: ''!
setController: aECController position: aPoint 
	controller := aECController.
	context := controller context.
	self createTitle.
	self position: aPoint - (20 @ 0).
	self narrowCompletion
		ifTrue: [self openInWorld]. 
! !

!NECMenuMorph methodsFor: 'drawing' stamp: ''!
show
	| extent height |
	firstVisible := 1.
	height := self visibleItemsCount * self class itemHeight.
	pageHeight := self height asInteger.
	self hasMessage ifTrue: [ height := height + self class itemHeight ].
	titleStringMorph ifNotNil: [ height := height max: titleStringMorph width + 30 ].
	extent := self class itemWidth @ height.
	self extent: extent.
	self changed! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
showDetail
	detailMorph ifNotNil: [ ^ self browse ].
	self itemsCount isZero ifTrue: [ ^ self ].
	detailMorph := NECDetailMorph new.
	self addMorph: detailMorph.
	self updateDetail! !

!NECMenuMorph methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/11/2012 15:05'!
stillActive! !

!NECMenuMorph methodsFor: 'actions' stamp: ''!
switchToUntyped
	context switchToUntyped.
	self removeTitle; narrowCompletion; changed! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
updateDetail
	detailMorph
		ifNil: [^ self].
	detailMorph
		entryDescription: (self selectedEntry descriptionWith: context).
	detailMorph position: detailPosition menuWidth: self width.
	detailMorph show! !

!NECMenuMorph methodsFor: 'private' stamp: ''!
visibleItemsCount.

	^ self lastVisible - self firstVisible + 1! !

!StringHolder methodsFor: '*necompletion-extensions' stamp: 'lr 3/26/2010 13:44'!
guessTypeForName: aString
	^ nil! !

!StringHolder methodsFor: '*necompletion-extensions' stamp: 'EstebanLorenzano 4/11/2012 15:33'!
isCodeCompletionAllowed
	^true! !

!StringHolder methodsFor: '*necompletion-extensions' stamp: ''!
receiverClass
	^nil! !

!Workspace methodsFor: '*necompletion' stamp: 'StephaneDucasse 2/26/2012 16:53'!
completionAdditionals
	| additionals |
	additionals := SortedCollection new.
	bindings ifNotNil: 
		[ bindings keysDo: 
			[ :each | 
			additionals add: (NECLocalEntry 
					contents: each
					type: #local) ] ].
	^ additionals! !

!Workspace methodsFor: '*necompletion' stamp: ''!
completionAdditionalsFromOCompletion
	"should spend more time to get it"
	
	bindings ifNil: [ ^#() ].
	^bindings keys asArray replace: [ :each | 
		NECLocalEntry 
			contents: each
			type: #local ]! !

!Workspace methodsFor: '*necompletion' stamp: 'StephaneDucasse 2/26/2012 18:01'!
createCompletionController
	^NECWorkspaceController model: self! !

!Workspace methodsFor: '*necompletion' stamp: 'lr 3/26/2010 13:55'!
guessTypeForName: aString
	| binding |
	bindings isNil ifFalse: [ 
		binding := bindings 
			at: aString
			ifAbsent: [ nil ].
		binding isNil
			ifFalse: [ ^ binding class ] ].
	^ super guessTypeForName: aString! !

!Workspace methodsFor: '*necompletion' stamp: ''!
guessTypeForNameFromOCompletion: aString
	"the difference is the ifAbsent: [nil] vs ifAbsent: [ ]"
	| binding |
	bindings ifNotNil: 
		[ binding := bindings 
			at: aString
			ifAbsent: [  ].
		binding ifNotNil: [ ^ binding class ] ].
	^ super guessTypeForName: aString! !

!Workspace methodsFor: '*necompletion' stamp: 'bar 12/16/2004 11:24'!
hasBindingOf: aString 
	^(self guessTypeForName: aString) notNil! !

!Workspace methodsFor: '*necompletion' stamp: 'bar 12/16/2004 11:26'!
hasBindingThatBeginsWith: aString
	^false! !

!TextMorph methodsFor: '*necompletion-extensions' stamp: 'EstebanLorenzano 4/11/2012 10:54'!
basicKeyStroke: evt 
	"Handle a keystroke event."
	| action |

	evt keyValue = 13
		ifTrue: [
			action := self crAction.
			action
				ifNotNil: ["Note: Code below assumes that this was some 
					input field reacting on CR. Break the keyboard 
					focus so that the receiver can be safely deleted."
					evt hand newKeyboardFocus: nil.
					^ action value]].
	self handleInteraction: [ editor keystroke: evt ].
	self updateFromParagraph.
	super keyStroke: evt.! !

!TextMorph methodsFor: '*necompletion-overrides' stamp: 'EstebanLorenzano 4/11/2012 10:54'!
keyStroke: evt 
	"Handle a keystroke event."

	Smalltalk tools 
		codeCompletionAround: [ self basicKeyStroke: evt ] 
		textMorph: self 
		keyStroke: evt.! !

!AbstractTool methodsFor: '*necompletion-extensions' stamp: 'EstebanLorenzano 4/12/2012 13:20'!
isCodeCompletionAllowed 
	^true! !

InstructionClient subclass: #NECVarTypeGuesser
	instanceVariableNames: 'types receiverClass variableName found currentMethod hasSend contextCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm an InstructionClient that tries to guess the type of a given instance variable name of a class. !

NECVarTypeGuesser subclass: #NECClassVarTypeGuesser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECClassVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm a simple InstructionClient that tries to guess the type of a given class variable name of a class. !

!NECClassVarTypeGuesser methodsFor: 'public' stamp: ''!
methodRefs
	| theClass classVarAssoc |
	theClass := receiverClass classThatDefinesClassVariable: variableName.
	classVarAssoc := theClass classPool associationAt: variableName asSymbol.
	classVarAssoc value 
		ifNil: [ ^ SystemNavigation new allCallsOn: classVarAssoc ]
		ifNotNil: [ ^ classVarAssoc value class ]! !

!NECClassVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
popIntoLiteralVariable: anAssociation 
	anAssociation key == variableName asSymbol 
		ifTrue: [ found := true ]
		ifFalse: [ self reset ]! !

!NECClassVarTypeGuesser methodsFor: 'instruction decoding' stamp: ''!
popIntoReceiverVariable: offset 
	self reset! !

!NECClassVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
send: selector super: supered numArgs: numberArguments 
! !

NECVarTypeGuesser subclass: #NECInstVarTypeGuesser
	instanceVariableNames: 'varIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECInstVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm a simple InstructionClient that tries to guess the type of a given instance variable name of a class. !

!NECInstVarTypeGuesser methodsFor: 'public' stamp: ''!
methodRefs
	| theClass selectors |
	theClass := receiverClass classThatDefinesInstanceVariable: variableName.
	theClass ifNil: [ ^ nil ].
	selectors := theClass whichSelectorsStoreInto: variableName.
	^ selectors collect: [ :each | 
		RGMethodDefinition realClass: theClass selector: each]! !

!NECInstVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
popIntoReceiverVariable: offset 
	varIndex = offset 
		ifTrue: [ found := true ]
		ifFalse: [ self reset ]! !

!NECInstVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
prepare: aCompiledMethod 
	| theClass |
	super prepare: aCompiledMethod.
	theClass := aCompiledMethod realClass.
	varIndex := (theClass allInstVarNames indexOf: variableName) - 1! !

!NECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: ''!
getClassFromTypeSuggestingName: aString 
	| firstUppercaseLetter className aStream aClass |
	aStream := WriteStream on: String new.
	aStream nextPut: aString first asUppercase.
	aStream
		nextPutAll: (aString copyFrom: 2 to: aString size).
	className := aStream contents.
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	firstUppercaseLetter := aString indexOfFirstUppercaseCharacter.
	className := firstUppercaseLetter > 1
				ifTrue: [aString copyFrom: firstUppercaseLetter to: aString size]
				ifFalse: [^ nil].
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	^ nil! !

!NECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: ''!
variableName: aString class: aClass 
	^self variableName: aString source: nil class: aClass ! !

!NECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: ''!
variableName: aString source: sourceString class: aClass 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance 
		setVariableName: aString
		source: sourceString
		class: aClass.
	^ newInstance! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
blockReturnTop
	contextCount := contextCount - 1! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
computeVarType
	| info tempNames name |
	types ifEmpty: [ ^ nil ].
	info := types first.
	(hasSend and: [ info isDefinedByMessageSend not ]) ifTrue: 
		[ info type: nil.
		^ info ].
	info isDefinedByTemporary not ifTrue: [ ^ info ].
	tempNames := (receiverClass compilerClass new 
		parse: currentMethod getSourceFromFile asString
		in: receiverClass
		notifying: nil) tempNames.
	name := tempNames at: info temporaryOffset + 1.
	info type: (self class getClassFromTypeSuggestingName: name).
	^ info! !

!NECVarTypeGuesser methodsFor: 'instance creation' stamp: ''!
initialize
	super initialize.
	types := OrderedCollection new.
	hasSend := false.
	contextCount := 0! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
interpretNextInstructionUsing: aScanner 
	found := false.
	aScanner interpretNextInstructionFor: self.
	^found
! !

!NECVarTypeGuesser methodsFor: 'public' stamp: ''!
methodRefs
	^ #()! !

!NECVarTypeGuesser methodsFor: 'public' stamp: ''!
perform
	| infos infosOfMethod methodRefs |
	variableName isEmpty
		ifTrue: [^ nil].
	methodRefs := self methodRefs.
	methodRefs
		ifNil: [^ nil]. 
	methodRefs isBehavior
		ifTrue: [^ methodRefs].
	contextCount := 0.
	infos := SortedCollection
				sortBlock: [:a :b | a priority <= b priority].
	methodRefs
		do: [:each | 
			self prepare: each.
			infosOfMethod := self typeOfVarIn: each compiledMethod.
			infos addAll: infosOfMethod].
	infos notEmpty
		ifTrue: [^ infos first type].
	^ nil! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
popIntoLiteralVariable: anAssociation 
	"Remove Top Of Stack And Store Into Literal Variable bytecode."
	self reset! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
popIntoTemporaryVariable: offset 
	"Remove Top Of Stack And Store Into Temporary Variable bytecode."
	self reset
! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
prepare: aCompiledMethod ! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
pushActiveContext
	"Push Active Context On Top Of Its Own Stack bytecode."
	contextCount := contextCount + 1! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
pushConstant: value 
	"Push Constant, value, on Top Of Stack bytecode."
	| info |
	contextCount > 0 ifTrue: [ ^ self ].
	value ifNotNil: 
		[ info := NECTypeInfo definedByLiteral: value class.
		types add: info ]! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
pushLiteralVariable: anAssociation 
	"Push Contents Of anAssociation On Top Of Stack bytecode."
	| info |
	contextCount > 0 ifTrue:[^self].

	info := NECTypeInfo definedByMessageSend: anAssociation value.
	types add: info! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
pushTemporaryVariable: offset 
	"Push Contents Of Temporary Variable Whose Index Is the  
	argument, offset, On Top Of Stack bytecode."
	| info |
		contextCount > 0 ifTrue:[^self].

	info := NECTypeInfo definedByTemporaryVar: offset.
	types add: info! !

!NECVarTypeGuesser methodsFor: 'private' stamp: ''!
reset
	contextCount > 0 ifTrue:[^self].
	types reset.
	hasSend := false.! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
send: selector super: supered numArgs: numberArguments 
	"Send Message With Selector, selector, bytecode. The argument,  
	supered, indicates whether the receiver of the message is specified with 
	'super' in the source method. The arguments of the message are found  
	in  
	the top numArguments locations on the stack and the receiver just  
	below them."
	contextCount > 0 ifTrue:[^self].

	hasSend := true! !

!NECVarTypeGuesser methodsFor: 'instance creation' stamp: ''!
setVariableName: aString source: aSourceString class: aClass 
	variableName := aString.
	receiverClass := aClass! !

!NECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: ''!
typeOfVarIn: aMethod 
	"Answer whether the receiver references an instance variable."
	| scanner end type infos |
	scanner := InstructionStream on: aMethod.
	end := scanner method endPC.
	currentMethod := aMethod.
	infos := OrderedCollection new.
	[ scanner pc <= end ] whileTrue: 
		[ (self interpretNextInstructionUsing: scanner) ifTrue: 
			[ type := self computeVarType.
			type ifNotNil: [ infos add: type ] ] ].
	^ infos! !

!Debugger methodsFor: '*necompletion' stamp: 'lr 3/26/2010 13:53'!
guessTypeForName: aString 
	| index object |
	index := self selectedContext tempNames
		indexOf: aString
		ifAbsent: [ nil ].
	object := index isNil
		ifFalse: [ self selectedContext namedTempAt: index ]
		ifTrue: [
			index := self receiver class allInstVarNames
				indexOf: aString
				ifAbsent: [ ^ super guessTypeForName: aString ].
			self receiver instVarAt: index ].
	^ object class
! !

!Debugger methodsFor: '*necompletion' stamp: ''!
guessTypeForNameFromOCompletion: aString
	"we should study that because it may be better" 
	| index object |
	index := (self selectedContext debuggerMap tempNamesForContext: self selectedContext)
				indexOf: aString
				ifAbsent: [].
	object := index
				ifNil: [index := self receiver class allInstVarNames
								indexOf: aString
								ifAbsent: [].
						index ifNil: [^ nil].
					self receiver instVarAt: index]
				ifNotNil: [self selectedContext tempAt: index].
	^ object class
! !

TestCase subclass: #NECClassVarTypeGuesserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECClassVarTypeGuesserTest methodsFor: 'utils' stamp: ''!
guessVariable: aString in: aClass expected: theClassExpected 
	| typeGuesser result |
	typeGuesser := NECClassVarTypeGuesser 
		variableName: aString
		class: aClass.
	result := typeGuesser perform.
	self assert: result == theClassExpected! !

!NECClassVarTypeGuesserTest methodsFor: 'tests' stamp: ''!
testClassVar
	self
		guessVariable: 'ClassVar'
		in: NECTestClass
		expected: ByteString! !

!NECClassVarTypeGuesserTest methodsFor: 'tests' stamp: ''!
testDependentsFieldsClassVar
	self
		guessVariable: 'DependentsFields'
		in: NECTestClass
		expected: WeakIdentityKeyDictionary! !

!NECClassVarTypeGuesserTest methodsFor: 'tests' stamp: ''!
testSuperClassVar
	self
		guessVariable: 'SuperClassVar'
		in: NECTestClass
		expected: Dictionary ! !

TestCase subclass: #NECContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECContextTest methodsFor: 'private' stamp: ''!
checkUntypedVariablesOnly: aString 
	| context model |
	context := self 
		createContextFor: aString
		at: aString size.
	self assert: context isVariablesOnly.
	model := context model.
	self assert: model hasMessage not.
	self assert: (model entriesOfType: #instVar) notEmpty.
	context narrowWith: 'a'.
	self assert: (model entriesOfType: #selector) isEmpty! !

!NECContextTest methodsFor: 'private' stamp: ''!
createContextFor: aString at: anInteger 
	^ NECContext
		controller: NECController new
		class: NECTestClass
		source: aString
		position: anInteger! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testBlockTemporaries
	| text temps context |
	text := 'testIt
	| a b c |
	a _ [ :each | |d | ^d].
	^self'.
	context := self 
		createContextFor: text
		at: 39.
	temps := context temporaries collect: [ :each | each contents ].
	self assert: temps size = 5.
	self assert: temps first = 'a'.
	self assert: temps second = 'b'.
	self assert: temps third = 'c'.
	self assert: temps fourth = 'each'.
	self assert: temps fifth = 'd'! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testBlockTemporariesBoxed
	| text temps context |
	text := 'testIt
	| a b c |
	a := [ :each | |d | d = a ifTrue:[ |x|  ] ifFalse:[ |y|.
	^self'.
	context := self 
		createContextFor: text
		at: 73.
	temps := context temporaries collect: [ :each | each contents ].
	self assert: temps size = 5.
	self assert: temps first = 'a'.
	self assert: temps second = 'b'.
	self assert: temps third = 'c'.
	self assert: temps fourth = 'each'.
	self assert: temps fifth = 'd'.
! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testCompletionToken
	| text context |
	text := 'testIt: aRectangle
	| abc |
	test.
	abc daf'.
	context := self createContextFor: text at: text size.
	self assert: context completionToken = 'daf'! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testCompletionTokenEmpty
	| text context |
	text := 'testIt: aRectangle
	| abc |
	test.
	abc daf '.
	context := self createContextFor: text at: text size.
	self assert: context completionToken = ''! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testCreateModel
	| text context |
	text := 'testIt: aRectangle
	aRectangle printS'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class == NECTypedModel.
	text := 'testIt:'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class = NECOverrideModel.
	text := 'testIt: rect
	rect is'.
	context := self createContextFor: text at: text size.
	self assert: context createModel class = NECUntypedModel! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testEmpty
	self createContextFor: '' at: 0! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testInTheMiddelOfAWord
	| text context |
	text := 'hagada'.
	context := self 
		createContextFor: text
		at: 4.
	self assert: context completionToken = 'haga'! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverArgument
	| text context |
	text := 'testIt: aRectangle
	aRectangle printS'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == Rectangle.
	text := 'testIt: rect
	rect is'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass isNil! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverCascade
	| text context |
	text := 'testIt
	| b |
	b _ Stream new.
	b 
		nextPutAll: ''test''; 
		nextPut: $c;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt
	| b |
	b _ Stream new
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt: aStream
	| test |
	aStream
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream.
	text := 'testIt: aStream
	aStream
		nextPutAll: ''test''; 
		nextPut: $c with: true;
		s'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Stream! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverClassVar
	| text context |
	text := 'testIt
	ClassVar '.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == ByteString! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverConstant
	| text context |
	text := 'testIt
	15r16 printS'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Number.
	text := 'testIt
	''test'' printS'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == String.
	text := 'testIt
	true ifTrue:'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == True.
	text := 'testIt
	false  "this is it"
		printStr'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == False.
	text := 'testIt
	a _ [ :test | test * test ] 
		v'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == BlockClosure.
	text := 'testIt
	$c as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Character.
	text := 'testIt
	#gaga as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Symbol.
	text := 'testIt
	#( 1 2 3) as'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Array.
! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverGlobal
	| text context |
	text := 'testIt
	Dictionary n'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary class.
! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverGlobalVarNew
	| text context |
	text := 'testIt
	Dictionary new a'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == Dictionary.
! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverTempVar
	| text context |
	text := 'testIt
	| aha |
	aha _ ''test''.
	aha p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == String.
	text := 'testIt
	| aha |
	ah _ ''test''.
	ah p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass isNil.
	text := 'testIt
	| aha |
	aha _ constantString.
	aha p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == ByteString.
	text := 'testIt
	| aha |
	aha _ constant asDate.
	aha p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass isNil.
	text := 'testIt
	| aha bili |
	aha _ constantString.
	bili _ aha.
	bili p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == ByteString.
	text := 'testIt
	| aha bili |
	aha _ constantString.
	bili _ aha _ 15.
	bili p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass = Number.
	text := 'testIt
	| aha bili |
	aha _ constantString.
	bili _ 15.
	bili _ aha.
	bili p'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == Number.
	text := 'testIt
	[ :each | |a| a _ 16. a print'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == Number.
	text := 'testIt
	[ :each | |a| a _ Dictionary new. a print'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == Dictionary.
	text := 'testIt
	[ :each | |a| a _ Dictionary. a print'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context receiverClass == Dictionary class! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testReceiverTempVar2
	| text context |
	text := 'openMenuFor: aParagraphEditor 
	| theMenu |
	context := NECContext
				controller: self
				class: model receiverClass
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	editor := aParagraphEditor.
	theMenu := NECMenuMorph
				controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed
		ifFalse: [menuMorph := theMenu]. theMenu o'.
	context := self createContextFor: text at: text size.
	self assert: context receiverClass == NECMenuMorph! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testTemporaries
	| text temps context |
	text := 'testIt: aRectangle
	| a b c |
	a _ [ :each | |d | ^d].
	^self'.
	context := self 
		createContextFor: text
		at: text size.
	temps := context temporaries collect: [ :each | each contents ].
	self assert: temps size = 4.
	self assert: temps first = 'aRectangle'.
	self assert: temps second = 'a'.
	self assert: temps third = 'b'.
	self assert: temps fourth = 'c'! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testUnfinishedString
	| text context |
	text := 'testIt: aRectangle
	| a b c |
	self test: ''test it and so'.
	context := self 
		createContextFor: text
		at: text size.
	self assert: context completionToken = 'so'! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testUntypedSelectorsOnly
	| text context model |
	text := 'testIt: aRectangle
	| ab bc bd |
	ab '.
	context := self 
		createContextFor: text
		at: text size.
	model := context model.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	context narrowWith: 'a'.
	self assert: (model entriesOfType: #selector) notEmpty.
	self assert: (model entriesOfType: #local) isEmpty.
	self assert: (model entriesOfType: #instance) isEmpty! !

!NECContextTest methodsFor: 'tests' stamp: ''!
testUntypedVarsOnly
	self checkUntypedVariablesOnly: 'testIt
	'.
	self checkUntypedVariablesOnly: '+ aTest
	'.
	self checkUntypedVariablesOnly: 'gaga: aTest
	'.
	self checkUntypedVariablesOnly: 'gaga
	^ '.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ '.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each'.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each |'.
	self checkUntypedVariablesOnly: 'testIt 
	a ifTrue:[ :each | '.
	self checkUntypedVariablesOnly: 'testIt
	<primitive: 67> 
	'.
	self checkUntypedVariablesOnly: 'testIt
	ab _'.
	self checkUntypedVariablesOnly: 'testIt
	ab _ '.
	self checkUntypedVariablesOnly: 'self compare: '.
	self checkUntypedVariablesOnly: 'self compare: x caseSensitive: '.
	self checkUntypedVariablesOnly: 'self gaga: x gugu: ('.
	self checkUntypedVariablesOnly: 'testIt
	a _ 15 + '.
	self checkUntypedVariablesOnly: 'testIt
	self hugatada: '! !

TestCase subclass: #NECEntryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECEntryTest methodsFor: 'tests' stamp: ''!
testCompletion
	| entry |
	entry := NECSelectorEntry 
		contents: 'makeItHappen'
		type: #unary:.
	self assert: entry completion = #makeItHappen! !

!NECEntryTest methodsFor: 'tests' stamp: ''!
testInstance
	| entry |
	entry := NECInstVarEntry 
		contents: 'abc'
		type: #instVar:.
	self assert: entry isInstance! !

!NECEntryTest methodsFor: 'tests' stamp: ''!
testLocal
	| entry |
	entry := NECLocalEntry 
		contents: 'abc'
		type: #patternArg:.
	self assert: entry contents = 'abc'.
	self assert: entry type = #patternArg:.
	self assert: entry isLocal! !

!NECEntryTest methodsFor: 'tests' stamp: ''!
testPrintOn
	| entry |
	entry := NECSelectorEntry 
		contents: 'compute'
		type: #unary:.
	self assert: 'NECSelectorEntry(compute,unary:)' = entry printString! !

TestCase subclass: #NECInstVarTypeGuesserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECInstVarTypeGuesserTest methodsFor: 'private' stamp: ''!
guessVariable: aString in: aClass expected: theClassExpected 
	| typeGuesser result |
	typeGuesser := NECInstVarTypeGuesser 
		variableName: aString
		class: aClass.
	result := typeGuesser perform.
	self assert: result == theClassExpected! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testComplexInit
	self
		guessVariable: 'complexInit'
		in: NECTestClass
		expected: nil! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testComplexInit2
	self 
		guessVariable: 'complexInit2'
		in: NECTestClass
		expected: Dictionary! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantArray
	self 
		guessVariable: 'constantArray'
		in: NECTestClass
		expected: Array! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantBoolean
	self 
		guessVariable: 'constantBoolean'
		in: NECTestClass
		expected: True! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantInteger
	self 
		guessVariable: 'constantInteger'
		in: NECTestClass
		expected: SmallInteger! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantIntegerNil
	self
		guessVariable: 'constantNil'
		in: NECTestClass
		expected: nil! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantString
	self
		guessVariable: 'constantString'
		in: NECTestClass
		expected: ByteString! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testConstantSymbol
	self
		guessVariable: 'constantSymbol'
		in: NECTestClass
		expected: ByteSymbol! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testGlobalVarKeyword
	self
		guessVariable: 'globalVarKeyword'
		in: NECTestClass
		expected: SortedCollection! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testGlobalVarKeyword2
	self
		guessVariable: 'globalVarKeyword2'
		in: NECTestClass
		expected: SortedCollection! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testMessageSend
	self 
		guessVariable: 'messageSend'
		in: NECTestClass
		expected: Dictionary! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testMessageSend2
	self 
		guessVariable: 'messageSend2'
		in: NECTestClass
		expected: nil! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testSuperWithAnotherInit
	self 
		guessVariable: 'superInstVar'
		in: NECTestClass
		expected: Dictionary! !

!NECInstVarTypeGuesserTest methodsFor: 'testing' stamp: ''!
testTypeSuggestingParameter
	self 
		guessVariable: 'typeSuggestingParameter2'
		in: NECTestClass
		expected: Rectangle! !

TestCase subclass: #NECOverrideModelTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
setUp
	model := NECOverrideModel class: NECTestClass.
	model toggleExpand! !

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
testCompletionAt
	| completion |
	completion := model completionAt: 2.
	self assert: completion = 'toBeOverriden: anArgument
	super toBeOverriden: anArgument'! !

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
testCompletionAtWithReturn
	| completion |
	completion := model completionAt: 3.
	self assert: completion = 'toBeOverridenWithReturn
	^ super toBeOverridenWithReturn'! !

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
testExpand
	| size |
	size := model entries size.
	self assert: size == model entries size! !

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
testOverride
	| selectors |
	self assert: model notEmpty.
	self assert: model entries size = 3.
	selectors := model entriesOfType: #selector.
	self
		assert: (selectors includes: #toBeOverriden:).
	self
		assert: (selectors includes: #initialize).
	self
		assert: (selectors includes: #toBeOverridenWithReturn)! !

!NECOverrideModelTest methodsFor: 'testing' stamp: ''!
testTitle
	self assert: '(override) NECTestSuperClass' = model title! !

TestCase subclass: #NECStringSortingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECStringSortingTest methodsFor: 'tests' stamp: ''!
testCaseSensitiveMap
	| map colon o |
	map := String classPool at: #CaseSensitiveOrder.
	colon := map at: $: asciiValue + 1.
	o := map at: $O asciiValue + 1.
	self assert: colon > o! !

!NECStringSortingTest methodsFor: 'tests' stamp: ''!
testCompare
	self assert: ('at:' compare: 'atOne' caseSensitive: false)
			== 1! !

!NECStringSortingTest methodsFor: 'tests' stamp: ''!
testCompareWithCase
	self assert: ('at:' compare: 'atOne' caseSensitive: true)
			== 3! !

TestCase subclass: #NECTypedModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECTypedModelTest methodsFor: 'tests' stamp: ''!
testExpand
	| model selectors |
	model := NECTypedModel class: NECTestClass.
	self assert: (model entriesOfType: #locals) isEmpty.
	self assert: (model entriesOfType: #instance) isEmpty.
	model toggleExpand.
	selectors := model entriesOfType: #selector.
	self assert: selectors size == 6.
	self assert: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self assert: (selectors includes: #testIt:).
	model toggleExpand.
	selectors := model entriesOfType: #selector.
	self assert: selectors size > 100.
	self assert: (selectors includes: #instVarAt:).
	self assert: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self assert: (selectors includes: #testIt:).
	self assert: (selectors includes: #instVarAt:).
	model toggleExpand.
	selectors := model entriesOfType: #selector.
	self assert: selectors size == 6! !

!NECTypedModelTest methodsFor: 'tests' stamp: ''!
testMessage
	| model |
	model := NECTypedModel class: NECTestClass.
	self shouldnt: model hasMessage.
	model narrowWith: 'hagadagadu'.
	self assert: model hasMessage.
	self assert: model message = 'no completions found'! !

!NECTypedModelTest methodsFor: 'tests' stamp: ''!
testTitle
	| model |
	model := NECTypedModel class: NECTestClass.
	self assert: #NECTestClass = model title! !

!NECTypedModelTest methodsFor: 'tests' stamp: ''!
testTyped
	| model selectors |
	model := NECTypedModel class: NECTestClass.
	self assert: (model entriesOfType: #locals) size == 0.
	self assert: (model entriesOfType: #instance) size == 0.
	selectors := model entriesOfType: #selector.
	self assert: selectors size > 0.
	self assert: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self assert: (selectors includes: #testIt:).
	model narrowWith: 'low'.
	selectors := model entriesOfType: #selector.
	self deny: (selectors includes: #initialize).
	self assert: (selectors includes: #lowPriorityOverrides:).
	self deny: (selectors includes: #testIt:)! !

TestCase subclass: #NECUntypedModelTest
	instanceVariableNames: 'prefValueCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
setUp
	prefValueCase := NECPreferences caseSensitive.
	NECPreferences caseSensitive: true! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
tearDown
	NECPreferences caseSensitive: prefValueCase! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testAdditionalLocals
	| model locals |
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: (OrderedCollection 
				with: (NECLocalEntry 
						contents: 'a'
						type: #local)
				with: (NECLocalEntry 
						contents: 'b'
						type: #local))
		additionals: (Array with: (NECLocalEntry 
				contents: 'veryImp'
				type: #local))
		variables: true
		selectors: true.
	locals := model entriesOfType: #local.
	self assert: (locals includes: 'veryImp')! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testCaseSensitive
	| model locals |
	self assert: NECPreferences caseSensitive.
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: OrderedCollection new.
	locals := model entriesOfType: #instVar.
	self assert: locals size == 17.
	self assert: (locals includes: 'third').
	self assert: (locals includes: 'constantInteger').
	self assert: (locals includes: 'complexInit2').
	self assert: (locals includes: 'typeSuggestingParameter').
	model narrowWith: 'fo'! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testCaseSensitivity
	| model instances |
	self assert: NECPreferences caseSensitive.
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: OrderedCollection new.
	model narrowWith: 'typesugg'.
	self assert: model isEmpty.
	NECPreferences caseSensitive: false.
	model narrowWith: 'typesugg'.
	instances := model entriesOfType: #instVar.
	self assert: instances size == 2.
	self assert: (instances includes: 'typeSuggestingParameter').
	model narrowWith: 'dict'.
	self assert: model notEmpty.
	self assert: ((model entriesOfType: #selector) includes: 'Dictionary')! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testEmpty
	| model |
	model := NECUntypedModel new.
	self assert: model isEmpty.
	self assert: model entries isEmpty.
	self assert: model entryCount == 0! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testForClassInstVars
	| model locals |
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: OrderedCollection new.
	locals := model entriesOfType: #instVar.
	self assert: locals size == 17.
	self assert: (locals includes: 'third').
	self assert: (locals includes: 'constantInteger').
	self assert: (locals includes: 'complexInit2').
	self assert: (locals includes: 'typeSuggestingParameter').
	locals := model entriesOfType: #self.
	self assert: (locals includes: 'self').
	locals := model entriesOfType: #super.
	self assert: (locals includes: 'super').
	model narrowWith: 'fo'.
	locals := model entriesOfType: #instVar.
	self assert: locals size == 1.
	self assert: (locals includes: 'fourth')! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testForClassLocals
	| model locals temps |
	temps := #('loc1' 'x2' 'bar' 'var' ) collect: 
		[ :each | 
		NECLocalEntry 
			contents: each
			type: #local ].
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: temps.
	locals := model entriesOfType: #local.
	self assert: locals size == 4.
	self assert: (locals includes: 'loc1').
	self assert: (locals includes: 'x2').
	self assert: (locals includes: 'bar').
	self assert: (locals includes: 'var').
	model narrowWith: 'l'.
	locals := model entriesOfType: #local.
	self assert: locals size == 1.
	self assert: (locals includes: 'loc1')! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testForClassVars
	| model classVars |
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: OrderedCollection new.
	classVars := model entriesOfType: #classVar.
	self assert: classVars size >= 2.
	self assert: (classVars includes: 'SuperClassVar').
	self assert: (classVars includes: 'ClassVar')! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testMessage
	| model |
	model := NECUntypedModel 
		class: NECTestClass
		temporaries: #('a' 'b' ).
	self assert: model notEmpty.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	model narrowWith: 'b'.
	self shouldnt: model hasMessage.
	model narrowWith: ''.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'.
	model narrowWith: 'hagadagadu'.
	self assert: model hasMessage.
	self assert: model message = 'no completions found'.
	model := NECUntypedModel new.
	self assert: model hasMessage.
	self assert: model message = 'press key for selectors'! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testNarrowWith
	| count model |
	model := NECUntypedModel new.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	count := model entryCount.
	self assert: count == model entries size.
	self assert: count > 100.
	model narrowWith: 'bar'.
	self assert: count > model entryCount.
	model narrowWith: 'barXXXX'.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	self assert: count == model entryCount.
	model narrowWith: 'save'.
	self assert: model isEmpty not.
	model narrowWith: ''.
	self assert: model isEmpty! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testNoEntriesWithSpace
	| model separatorEntry |
	model := NECUntypedModel new.
	self assert: model isEmpty.
	model narrowWith: 'b'.
	separatorEntry := model entries detect: 
					[:each | 
					(each value asString detect: [:char | char isSeparator] ifNone: []) notNil]
				ifNone: [].
	self assert: separatorEntry isNil! !

!NECUntypedModelTest methodsFor: 'tests' stamp: ''!
testTitle
	| model |
	model := NECUntypedModel
				class: NECTestClass
				temporaries: #().
	self assert: model title isNil! !

SystemWindow subclass: #NECHelpMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-View'!

!NECHelpMorph commentStamp: '<historical>' prior: 0!
I am a system window that displays the keybindings of eCompletion. The text is static and generated in the class methods.!

!NECHelpMorph class methodsFor: 'private' stamp: ''!
explanationAttributes
	^{TextIndent spaceUsed; tabs: 2}! !

!NECHelpMorph class methodsFor: 'help-text' stamp: ''!
helpText
	| stream |
	stream := TextStream on: Text new.
	self 
		section: 'character completion'
		on: stream.
	self 
		shortcut: 'works on'
		text: ' [] {} () <> '''' ""'
		on: stream.
	self 
		shortcut: 'usage 1'
		text: 'enter open character - closing character is entered as well'
		on: stream.
	self 
		shortcut: 'usage 2'
		text: 'select some text, enter a smart character and the selected text get surrounded by the opening and closing character.'
		on: stream.
	self 
		section: 'open/close menu'
		on: stream.
	self 
		shortcut: 'ctrl-space or tab'
		text: 'open the completion menu'
		on: stream.
	self 
		shortcut: 'ESC'
		text: 'close menu'
		on: stream.
	self 
		shortcut: 'ctrl-h'
		text: 'open this help'
		on: stream.
	self 
		section: 'menu navigation'
		on: stream.
	self 
		shortcut: 'Arrows up/down'
		text: 'move the selection up and down'
		on: stream.
	self 
		shortcut: 'Page up/down'
		text: 'page up and down'
		on: stream.
	self 
		shortcut: 'Home/End'
		text: 'move to first or last page of the menu'
		on: stream.
	self 
		section: 'show details and browse'
		on: stream.
	self 
		shortcut: 'right arrow (detail closed)'
		text: 'show details about the selected item. This may be the type of the variable, the source of a method or the implementors of the selector.'
		on: stream.
	self 
		shortcut: 'right arrow (detail open)'
		text: 'open a new browser for the selected item.'
		on: stream.
	self 
		shortcut: 'left arrow'
		text: 'close the details'
		on: stream.
	self 
		section: 'changing menu contents'
		on: stream.
	self 
		shortcut: 'ctrl-u'
		text: 'switch to untyped mode in a typed menu'
		on: stream.
	self 
		shortcut: 'ctrl-t'
		text: 'filter out methods of class Object in a typed menu. press again to make the reappear.'
		on: stream.
	self 
		shortcut: 'alphanumeric character'
		text: 'filter the menu to the given input'
		on: stream.
	self 
		shortcut: 'backspace'
		text: 'delete an input character, adjust menu to the new input.'
		on: stream.
	self 
		section: 'inserting completion'
		on: stream.
	self 
		shortcut: 'ctrl-space or tab'
		text: 'close the menu and insert selected completion. if there only one item left in the menu this done automaticly.'
		on: stream.
	^ stream contents! !

!NECHelpMorph class methodsFor: 'private' stamp: ''!
section: aString on: aTextStream 
	aTextStream
		withAttributes: self sectionAttributes
		do: [aTextStream nextPutAll: aString].
	aTextStream cr! !

!NECHelpMorph class methodsFor: 'private' stamp: ''!
sectionAttributes
	^ {TextEmphasis bold}! !

!NECHelpMorph class methodsFor: 'private' stamp: ''!
shortcut: aString text: secondString on: aTextStream 
	aTextStream
		withAttributes: self shortcutAttributes
		do: [aTextStream nextPutAll: aString;
				 cr].
	aTextStream
		withAttributes: self explanationAttributes
		do: [aTextStream nextPutAll: secondString;
				 cr].
! !

!NECHelpMorph class methodsFor: 'private' stamp: ''!
shortcutAttributes
	^ {TextIndent spaceUsed; tabs: 1. TextEmphasis italic }! !

!NECHelpMorph methodsFor: 'initialize' stamp: ''!
contents
	^self class helpText ! !

!NECHelpMorph methodsFor: 'initialize' stamp: ''!
defaultColor
	^ NECMenuMorph backgroundColor! !

!NECHelpMorph methodsFor: 'initialize' stamp: ''!
initialize

	| text |
	super initialize.
	self setLabel: 'eCompletion Keyboard Help'.
	"self height: ECMenuMorph itemHeight * 60."
	text := PluggableTextMorph
				on: self
				text: #contents
				accept: nil
				readSelection: nil
				menu: nil.
	self
		addMorph: text
		frame: (0 @ 0 corner: 1.0 @ 1.0).
	text lock.! !

Object subclass: #NECContext
	instanceVariableNames: 'source position theClass ranges completionIndex recurseCount receiverClass completionToken model controller variables selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECContext commentStamp: '<historical>' prior: 0!
A completion is started by the ECController. The controller creates me to compute the context of the completion. The most important information about the context are the receiverClass and the completionToken. I create a ECModel or subclass when requested by the 'model' method.

I use SHParser and SHRange to parse the text input.!

!NECContext class methodsFor: 'instance creation' stamp: ''!
controller: aECController class: aClass source: aString position: anInteger 
	^ self basicNew initialize
		setController: aECController
		class: aClass
		source: aString
		position: anInteger! !

!NECContext methodsFor: 'private-temporaries' stamp: ''!
blockTemporaries
	| blocks range vars |
	blocks := OrderedCollection new.
	1 
		to: completionIndex - 1
		do: 
			[ :index | 
			range := ranges at: index.
			self 
				handleBlockStack: blocks
				with: range.
			range isBlockTemporary ifTrue: 
				[ vars := blocks last.
				vars add: range ] ].
	^ self convertBlocksToVariables: blocks! !

!NECContext methodsFor: 'private-compute-index' stamp: ''!
checkForZeroPosition
	^ (position = 0
			or: [ranges isEmpty])
		and: [self insertEmptyRangeAt: 1 start: 0 end: 1.
			true]! !

!NECContext methodsFor: 'private-receiver-guessing' stamp: ''!
checkImpossibleReceiver
	^ self isSelectorsAndVariables
		ifTrue: [self configureSelectorsAndVariables]
		ifFalse: [self isVariablesOnly
				ifTrue: [self configureVariablesOnly]
				ifFalse: [self isSelectorsOnly
						and: [self configureSelectorsOnly]]]. ! !

!NECContext methodsFor: 'accessing' stamp: ''!
completionToken
	completionToken ifNil: 
		[ | range |
		range := ranges at: completionIndex.
		completionToken := self 
			sourceOf: range
			stopAt: position.
		completionToken := completionToken wordBefore: completionToken size ].
	^ completionToken! !

!NECContext methodsFor: 'private' stamp: ''!
compute
	completionIndex := self computeIndexOfPosition.
	receiverClass := self computeReceiverClass! !

!NECContext methodsFor: 'private-compute-index' stamp: ''!
computeIndexOfPosition
	| current |
	self checkForZeroPosition ifTrue: [ ^ 1 ].
	1 
		to: ranges size
		do: 
			[ :index | 
			current := ranges at: index.
			(current includesPosition: position) 
				ifTrue: [ ^ index ]
				ifFalse: 
					[ current end > position ifTrue: [ ^ self createEmptyRangeForGapAt: index ] ] ].
	^ self createEmptyRangeAtTail! !

!NECContext methodsFor: 'private' stamp: ''!
computeReceiverClass
	| previous found |
	recurseCount := 0.
	completionIndex = 1 ifTrue: [^nil].
	found := self checkImpossibleReceiver.
	found ifTrue: [^nil].
	previous := ranges at: completionIndex - 1.
	previous type = #cascadeSeparator 
		ifTrue: [^self guessCascadeReceiver: completionIndex - 1].
	(previous type = #unary 
		and: [(self sourceOf: previous) = 'new' and: [completionIndex > 2]]) 
			ifTrue: 
				[previous := ranges at: completionIndex - 2.
				previous type = #globalVar 
					ifTrue: [^self guessTypeOf: completionIndex - 2]
					ifFalse: 
						[self configureSelectorsOnly.
						^nil]].
	^self guessTypeOf: completionIndex - 1! !

!NECContext methodsFor: 'private-configure' stamp: ''!
configureSelectorsAndVariables
	variables := true.
	selectors := true.
	^true! !

!NECContext methodsFor: 'private-configure' stamp: ''!
configureSelectorsOnly
	variables := false.
	selectors := true.
	^true! !

!NECContext methodsFor: 'private-configure' stamp: ''!
configureVariablesOnly
	variables := true.
	selectors := false.
	^true! !

!NECContext methodsFor: 'private-temporaries' stamp: ''!
convertBlocksToVariables: anOrderedCollection 
	| result blockStack |
	blockStack := anOrderedCollection.
	result := OrderedCollection new.
	blockStack do: [ :each | result addAll: each ].
	^ result! !

!NECContext methodsFor: 'private-compute-index' stamp: ''!
createEmptyRangeAtTail
	| previous |
	previous := ranges last.
	ranges add: (SHRange 
			start: previous end + 1
			end: source size
			type: #empty).
	^ ranges size! !

!NECContext methodsFor: 'private-compute-index' stamp: 'EstebanLorenzano 4/18/2012 12:52'!
createEmptyRangeForGapAt: index 
	| current previous |
	current := ranges at: index.
	previous := ranges at: (index - 1 max: 1).
	self 
		insertEmptyRangeAt: index
		start: previous end + 1
		end: current start - 1.
	^ index! !

!NECContext methodsFor: 'accessing' stamp: ''!
createModel
	| modelClass |
	self receiverClass
		ifNotNil: [^ NECTypedModel class: receiverClass].
	(controller workspace isNil
		and: [theClass notNil])
		ifTrue: [completionIndex = 1
				ifTrue: [^ NECOverrideModel class: theClass]].
			
	modelClass := NECUntypedModel.		
	(controller model respondsTo: #modelClass) ifTrue: [controller model modelClass ifNotNilDo: [:class | modelClass :=  class]].		
	^ modelClass
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors! !

!NECContext methodsFor: 'private' stamp: ''!
createRanges
	| parser |
	parser := SHParserST80 new.
	ranges := parser 
				rangesIn: source
				classOrMetaClass: theClass
				workspace: controller workspace
				environment: nil.
	ranges := ranges select: [:each | each type ~= #comment]! !

!NECContext methodsFor: 'private-roel-typer' stamp: ''!
findCommonSuperclass: aCollection
	| current |
	aCollection isEmpty
		ifTrue: [ ^ nil ].
	current := aCollection first.
	aCollection do: [ :class |
		[ class includesBehavior: current ]
			whileFalse: [ current := current superclass ] ].
	^ current! !

!NECContext methodsFor: 'private' stamp: ''!
findSourceRangeFor: aNumber 
	aNumber
		to: ranges size
		by: 2
		do: [:index | 
			index + 3 > ranges size
				ifTrue: [^ nil].
			(ranges at: index + 1) isAssignment
				ifTrue: [(ranges at: index + 3) type = #statementSeparator
						ifTrue: [^ index + 2]
						ifFalse: [(ranges at: index + 2) type = #globalVar
								ifTrue: [^ index + 2]
								ifFalse: [(ranges at: index + 1) isAssignment 
										ifFalse: [^ nil]]]]]! !

!NECContext methodsFor: 'private-type-guessing' stamp: ''!
guessArgument: aSHRange 
	| name |
	name := self sourceOf: aSHRange.
	(name = 'html' and: [ (Smalltalk 
		at: #WARenderCanvas
		ifAbsent: [  ]) notNil ]) ifTrue: [ ^ Smalltalk at: #WARenderCanvas ].
	^ NECInstVarTypeGuesser getClassFromTypeSuggestingName: name! !

!NECContext methodsFor: 'private' stamp: ''!
guessCascadeReceiver: aNumber 
	| type |
	aNumber 
		to: 1
		by: -1
		do: 
			[ :index | 
			type := (ranges at: index) type.
			((#(#statementSeparator #assignment #ansiAssignment ) includes: type) or: [ (type beginsWith: 'pattern') or: [ type beginsWith: 'methodTemp' ] ]) ifTrue: [ ^ self guessTypeOf: index + 1 ] ].
	^ nil! !

!NECContext methodsFor: 'private' stamp: ''!
guessClassVarClass: aSHRange 
	| aClass name |
	name := self sourceOf: aSHRange.
	aClass := controller guessTypeFor: name.
	aClass
		ifNotNil: [^ aClass].
	^ (NECClassVarTypeGuesser variableName: name class: theClass theMetaClass) perform! !

!NECContext methodsFor: 'private-type-guessing' stamp: ''!
guessGlobal: aNumber 
	| aClass |
	aClass := Smalltalk 
		at: (self sourceOf: (ranges at: aNumber)) asSymbol
		ifAbsent: [ ^ nil ].
	aClass isBehavior ifFalse: [ ^ nil ].
	aNumber = (completionIndex - 1) ifTrue: [ ^ aClass class ].
	(ranges size >= (aNumber + 1) and: [ (ranges at: aNumber + 1) type = #statementSeparator ]) ifTrue: [ ^ aClass class ].
	^ aClass! !

!NECContext methodsFor: 'private' stamp: ''!
guessInstVarClass: aSHRange 
	| aClass name |
	name := self sourceOf: aSHRange.
	aClass := controller guessTypeFor: name.
	aClass ifNotNil: [ ^ aClass ].
	aClass := self 
		guessWithRoelTyper: name
		class: theClass.
	aClass ifNotNil: [ ^ aClass ].
	^ (NECInstVarTypeGuesser 
		variableName: name
		class: theClass) perform! !

!NECContext methodsFor: 'private' stamp: ''!
guessTempVarClass: aSHRange 
	^self guessTempVarClass: (self sourceOf: aSHRange) type: aSHRange type.
! !

!NECContext methodsFor: 'private' stamp: ''!
guessTempVarClass: aString type: aSymbol 
	| current type varName varType sourceIndex aClass |
	aClass := controller guessTypeFor: aString.
	aClass ifNotNil: [ ^ aClass ].
	varName := aString.
	varType := aSymbol.
	1 
		to: completionIndex
		do: 
			[ :index | 
			current := ranges at: index.
			(current type = varType and: [ (self sourceOf: current) = varName and: [ index + 3 <= ranges size ] ]) ifTrue: 
				[ (sourceIndex := self findSourceRangeFor: index) notNil ifTrue: 
					[ type := self guessTypeOf: sourceIndex.
					type ifNotNil: [ ^ type ] ] ] ].
	^ nil! !

!NECContext methodsFor: 'private-type-guessing' stamp: ''!
guessTypeOf: aNumber 
	| range |
	self configureSelectorsOnly.
	recurseCount > 10 ifTrue: [ ^ nil ].
	recurseCount := recurseCount + 1.
	range := ranges at: aNumber.
	^ range isSelf 
		ifTrue: [ theClass ]
		ifFalse: 
			[ range isSuper 
				ifTrue: [ theClass superclass ]
				ifFalse: 
					[ range isConstant 
						ifTrue: [ range asType ]
						ifFalse: 
							[ range isArgument 
								ifTrue: [ self guessArgument: range ]
								ifFalse: 
									[ range isTemporaryVariable 
										ifTrue: [ self guessTempVarClass: range ]
										ifFalse: 
											[ range isInstanceVariable 
												ifTrue: [ self guessInstVarClass: range ]
												ifFalse: 
													[ range isClassVariable 
														ifTrue: [ self guessClassVarClass: range ]
														ifFalse: [ range isGlobal ifTrue: [ self guessGlobal: aNumber ] ] ] ] ] ] ] ]! !

!NECContext methodsFor: 'private-roel-typer' stamp: ''!
guessWithRoelTyper: aString class: aClass 
	| typeCollector typeClass typeInfo types type |
	typeCollector := Smalltalk classNamed: #TypeCollector.
	typeCollector ifNil: [ ^ nil ].
	typeClass := aClass whichClassDefinesInstVar: aString.
	typeClass ifNil: [ ^ nil ].
	typeInfo := (typeCollector typeInstvarsOfClass: typeClass)
		at: aString asSymbol
		ifAbsent: [ ^ nil ].
	types := typeInfo types size <= 2
		ifTrue: [ typeInfo types ]
		ifFalse: [ typeInfo types intersection: typeInfo assignments ].
	type := types isEmpty
		ifFalse: [ self findCommonSuperclass: types ].
	^ type == Object 
		ifFalse: [ type ]! !

!NECContext methodsFor: 'private-temporaries' stamp: ''!
handleBlockStack: aCollection with: aSHRange 
	| range blockStack |
	range := aSHRange.
	blockStack := aCollection.
	range isBlockStart 
		ifTrue: [ blockStack add: OrderedCollection new ]
		ifFalse: [ range isBlockEnd ifTrue: [ blockStack removeLast ] ]! !

!NECContext methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	source := String new.
	position := 0.
	recurseCount := 0.
	variables := true.
	selectors := true.
	ranges := OrderedCollection new.
	completionIndex := 0.
	completionToken := nil! !

!NECContext methodsFor: 'private-compute-index' stamp: ''!
insertEmptyRangeAt: index start: start end: end 
	ranges
		add: (SHRange
				start: start
				end: end
				type: #empty)
		beforeIndex: index! !

!NECContext methodsFor: 'private-receiver-guessing' stamp: ''!
isSelectorsAndVariables
	| current |
	current := ranges at: completionIndex.
	^current isUnfinished! !

!NECContext methodsFor: 'private-receiver-guessing' stamp: ''!
isSelectorsOnly
	| previous |
	previous := ranges at: completionIndex - 1.
	^previous isOpening! !

!NECContext methodsFor: 'private-receiver-guessing' stamp: ''!
isVariablesOnly
	| current previous |
	current := ranges at: completionIndex.
	^ current isVariablesOnly or: 
		[ current isOpening or: 
			[ previous := ranges at: completionIndex - 1.
			previous isOpening or: 
				[ previous isSeparator or: 
					[ previous isKeyword or: [ previous isAssignment or: [ previous isBinary ] ] ] ] ] ]! !

!NECContext methodsFor: 'accessing' stamp: ''!
model
	model isNil ifTrue: [ model := self createModel ].
	^ model! !

!NECContext methodsFor: 'action' stamp: ''!
narrowWith: aString 
	completionToken := aString.
	model ifNotNil: [ model narrowWith: aString ]! !

!NECContext methodsFor: 'private' stamp: ''!
receiverClass
	^ receiverClass! !

!NECContext methodsFor: 'initialize-release' stamp: ''!
setController: aECController class: aClass source: aString position: anInteger 
	controller := aECController.
	theClass := aClass.
	source := aString.
	position := anInteger.
	self createRanges.
	self compute! !

!NECContext methodsFor: 'private' stamp: ''!
sourceOf: aSHRange 
	^aSHRange isString
		ifTrue: [aSHRange]
		ifFalse: [self sourceOf: aSHRange stopAt: aSHRange end]! !

!NECContext methodsFor: 'private' stamp: ''!
sourceOf: aSHRange stopAt: aNumber
	^ aSHRange type = #empty
		ifTrue: [String new]
		ifFalse: [source copyFrom: aSHRange start to: aNumber]! !

!NECContext methodsFor: 'action' stamp: ''!
switchToUntyped
	receiverClass := nil.
	self configureSelectorsAndVariables.
	model := self createModel! !

!NECContext methodsFor: 'accessing' stamp: ''!
temporaries
	| tempRanges |
	tempRanges := ranges select: [ :each | #(#patternTempVar #patternArg ) includes: each type ].
	tempRanges addAll: self blockTemporaries.
	^ tempRanges collect: 
		[ :each | 
		NECLocalEntry 
			contents: (self sourceOf: each)
			type: each type ]! !

!NECContext methodsFor: 'accessing' stamp: ''!
theClass
	^theClass! !

Object subclass: #NECController
	instanceVariableNames: 'model menuMorph editor context inverseMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-View'!

NECController class
	instanceVariableNames: 'uniqueInstance'!

!NECController commentStamp: '<historical>' prior: 0!
I live as an instance variable in a Browser, Debugger, Workspace or other window. I'm the glue between all participants of the completion system. I create the NECContext and pass myself to the NECMenuMorph. I process the keyboard events and pass them to the NECMenuMorph or close the morph if needed.!

NECController class
	instanceVariableNames: 'uniqueInstance'!

!NECController class methodsFor: 'testing' stamp: 'EstebanLorenzano 4/12/2012 13:24'!
allowModel: aModel 
	^NECPreferences enabled and: [ aModel isCodeCompletionAllowed ]! !

!NECController class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 13:25'!
codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	"Inserts code completion if allowed in this morph"
	
	| editor stringHolder completionAllowed controller |
	
	editor := aTextMorph editor.
	stringHolder := editor ifNotNil:[ editor model ].
	completionAllowed := self allowModel: stringHolder.
	completionAllowed 
		ifTrue: [ 
			controller := self uniqueInstance.
			controller setModel: stringHolder.
			(controller handleKeystrokeBefore: evt editor: editor)
				ifTrue:  [^ self ] ].

	aBlock value.
	
	completionAllowed
		ifTrue: [ controller handleKeystrokeAfter: evt editor: editor ]! !

!NECController class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 4/12/2012 13:43'!
initialize 
	self register! !

!NECController class methodsFor: 'instance creation' stamp: ''!
model: aStringHolder 
	^self new setModel: aStringHolder! !

!NECController class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 13:44'!
register
	self registerToolsOn: Smalltalk tools.! !

!NECController class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/11/2012 10:47'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #codeCompletion
! !

!NECController class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/11/2012 15:08'!
reset
	uniqueInstance := nil
	! !

!NECController class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/11/2012 11:26'!
uniqueInstance
	^uniqueInstance ifNil: [ uniqueInstance := self basicNew initialize ]! !

!NECController methodsFor: 'accessing' stamp: ''!
additionals
	^ nil! !

!NECController methodsFor: 'menu morph' stamp: ''!
closeMenu
	menuMorph
		ifNotNil: [menuMorph delete]! !

!NECController methodsFor: 'accessing' stamp: ''!
context
	^context! !

!NECController methodsFor: 'private' stamp: 'EstebanLorenzano 4/11/2012 16:40'!
contextClass
	^NECContext! !

!NECController methodsFor: 'accessing' stamp: ''!
editor
	^ editor! !

!NECController methodsFor: 'type guessing' stamp: ''!
guessTypeFor: aString
	^ model isNil ifFalse: [ model guessTypeForName: aString ]! !

!NECController methodsFor: 'keyboard' stamp: ''!
handleKeystrokeAfter: aKeyboardEvent editor: aParagraphEditor 
	(aParagraphEditor isNil or: [ self isMenuOpen not ])
		ifTrue: [ ^ self ].
	self setModel: aParagraphEditor model.
	context narrowWith: aParagraphEditor wordAtCaret.
	menuMorph narrowCompletion! !

!NECController methodsFor: 'keyboard' stamp: 'EstebanLorenzano 4/11/2012 11:42'!
handleKeystrokeBefore: aKeyboardEvent editor: anEditor 
	"I return a boolean. true when I have handled the event and no futher 
	processing 
	is needed by the caller."
	| keyValue controlKeyPressed isSpaceKey |
	self setEditor: anEditor.
	self setModel: editor model.
	keyValue := aKeyboardEvent keyValue.
	controlKeyPressed := aKeyboardEvent controlKeyPressed.
	isSpaceKey := #(0 32 ) includes: keyValue.
	"Ctrl-Space or Tab for open"
	self isMenuOpen
		ifFalse: [(isSpaceKey & controlKeyPressed
					or: [keyValue = 9
							and: [editor isCaretBehindChar
									and: [controlKeyPressed not]]])
				ifTrue: [self openMenuFor: editor.
					^ true]
				ifFalse: [(self smartInput: keyValue)
						ifNotNil: [^ true]].
			^ false].
	"Home"
	keyValue = 1
		ifTrue: [menuMorph home.
			^ true].
	"End"
	(keyValue = 4
			and: [controlKeyPressed not])
		ifTrue: [menuMorph end. 
			^ true].
	"Right-Arrow"
	keyValue = 29
		ifTrue: [menuMorph showDetail.
			^ true].
	"Left Arrow"
	keyValue = 28
		ifTrue: [menuMorph hideDetail.
			^ true].
	"Arrow up"
	keyValue = 30
		ifTrue: [menuMorph moveUp.
			^ true].
	"Arrow down"
	keyValue = 31
		ifTrue: [menuMorph moveDown.
			^ true].
	"Page up"
	keyValue = 11
		ifTrue: [menuMorph pageUp.
			^ true].
	"Page down"
	keyValue = 12
		ifTrue: [menuMorph pageDown.
			^ true].
	"Tab or Ctrl-Space"
	(keyValue = 13
			or: [isSpaceKey & controlKeyPressed
					or: [keyValue = 9]])
		ifTrue: [menuMorph insertSelected
				ifTrue: [^ true]].
	"Ctrl-h"
	(keyValue = 104 and: [ aKeyboardEvent commandKeyPressed ]) ifTrue: [ 
		menuMorph help.
		^ true ].
	"Ctrl-t"
	(keyValue = 116 and: [ aKeyboardEvent commandKeyPressed ]) ifTrue: [ 
		menuMorph expand.
		^ true ].
	"Ctrl-u"
	(keyValue = 117 and: [ aKeyboardEvent commandKeyPressed ]) ifTrue: [ 
		menuMorph switchToUntyped.
		^ true ].	
	"All keys but the alphanumeric chars (without command and control ) 
	and the backspace key do close the menu"
	keyValue = 8
		ifTrue: [editor isCaretBehindChar not
				ifTrue: [self closeMenu].
			^ false].
	(controlKeyPressed not & aKeyboardEvent commandKeyPressed not
			and: [aKeyboardEvent keyCharacter isAlphaNumeric])
		ifFalse: [self closeMenu.
			^ keyValue = 27].
	^ false! !

!NECController methodsFor: 'keyboard' stamp: ''!
invalidateEditorMorph
		editor morph invalidRect: editor morph bounds.
! !

!NECController methodsFor: 'menu morph' stamp: 'EstebanLorenzano 4/18/2012 11:05'!
isMenuEmpty
	^menuMorph isNil or: [ self context model notNil and: [ self context model isEmpty ] ]! !

!NECController methodsFor: 'menu morph' stamp: ''!
isMenuOpen
	^menuMorph notNil! !

!NECController methodsFor: 'menu morph' stamp: ''!
menuClosed
	menuMorph := nil.
	context := nil.! !

!NECController methodsFor: 'private' stamp: 'EstebanLorenzano 4/11/2012 16:49'!
menuMorphClass
	^ NECMenuMorph! !

!NECController methodsFor: 'accessing' stamp: ''!
model
	^model! !

!NECController methodsFor: 'menu morph' stamp: 'EstebanLorenzano 4/11/2012 16:49'!
openMenuFor: aParagraphEditor 
	| theMenu |
	context := self contextClass
				controller: self
				class: model selectedClassOrMetaClass 
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	editor := aParagraphEditor.
	theMenu := self menuMorphClass
				controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed
		ifFalse: [menuMorph := theMenu]. ! !

!NECController methodsFor: 'private' stamp: 'EstebanLorenzano 4/11/2012 11:41'!
setEditor: anObject
	editor := anObject! !

!NECController methodsFor: 'initialize-release' stamp: ''!
setModel: aStringHolder 
	model := aStringHolder! !

!NECController methodsFor: 'keyboard' stamp: 'EstebanLorenzano 4/11/2012 17:51'!
smartBackspace
	| opposite |
	editor hasSelection
		ifTrue: [ ^ nil ].
	opposite := self smartCharactersMapping
		at: (editor text
			at: editor startIndex - 1
			ifAbsent: [ ^ nil ])
		ifAbsent: [ ^ nil ].
	opposite = (editor text at: editor stopIndex ifAbsent: [ ^ nil ])
		ifFalse: [ ^ nil ].
	editor selectInvisiblyFrom: editor startIndex - 1 to: editor stopIndex.
	editor replaceSelectionWith: String new.
	self invalidateEditorMorph.
	^ true
	
! !

!NECController methodsFor: 'keyboard' stamp: 'EstebanLorenzano 4/11/2012 17:52'!
smartCharacter: aCharacter
	| opposite previous next |
	editor hasSelection ifTrue: [
		opposite := self smartCharactersMapping
			at: aCharacter
			ifAbsent: [ ^ nil ].
		editor replaceSelectionWith: (String with: aCharacter) , (editor selection) , (String with: opposite).
		editor selectFrom: editor stopIndex to: editor stopIndex - 1.
		self invalidateEditorMorph.
		^ true ].	
	opposite := self smartCharactersMapping at: aCharacter ifAbsent: [
		self smartInverseMapping
			at: aCharacter
			ifAbsent: [ ^ nil ].
		editor blinkPrevParen: aCharacter.
		(editor text at: editor startIndex ifAbsent: [ ^ nil ]) = aCharacter
			ifFalse: [ ^ nil ].
		editor selectFrom: editor startIndex + 1 to: editor startIndex.
		self invalidateEditorMorph.
		^ true ].
	previous := editor text at: editor startIndex - 1 ifAbsent: [ Character space ].
	next := editor text at: editor startIndex ifAbsent: [ Character space ].
	(previous isSeparator or: [ next isSeparator ])
		ifFalse: [ ^ nil ].
	(opposite = aCharacter and: [ next = aCharacter ]) ifTrue: [
		editor selectFrom: editor startIndex + 1 to: editor startIndex.
		self invalidateEditorMorph.
		^ true ].
	editor replaceSelectionWith: (String with: aCharacter with: opposite).
	editor selectFrom: editor startIndex + 1 to: editor startIndex.
	self invalidateEditorMorph.
	^ true! !

!NECController methodsFor: 'settings' stamp: ''!
smartCharacters
	^ NECPreferences smartCharacters ! !

!NECController methodsFor: 'settings' stamp: ''!
smartCharactersMapping
	^ NECPreferences smartCharactersMapping ! !

!NECController methodsFor: 'keyboard' stamp: ''!
smartInput: anInteger 
	self smartCharacters 
		ifFalse: [ ^ nil ].
	^ anInteger = 8
		ifTrue: [ self smartBackspace ]
		ifFalse:  [ self smartCharacter: anInteger asCharacter ]! !

!NECController methodsFor: 'settings' stamp: ''!
smartInverseMapping
	^ inverseMapping ifNil: [ 
		inverseMapping := Dictionary new.
		self smartCharactersMapping
			keysAndValuesDo: [ :key :value | inverseMapping at: value put: key ].
		inverseMapping ]! !

!NECController methodsFor: 'accessing' stamp: ''!
workspace
	^nil! !

NECController subclass: #NECWorkspaceController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-View'!

!NECWorkspaceController commentStamp: '<historical>' prior: 0!
I'm a specialized controller, that works with Workspaces.!

!NECWorkspaceController methodsFor: 'accessing' stamp: ''!
additionals
	^ self workspace completionAdditionals! !

!NECWorkspaceController methodsFor: 'accessing' stamp: ''!
workspace
	^model! !

Object subclass: #NECEntry
	instanceVariableNames: 'contents type description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECEntry commentStamp: 'bar 10/5/2005 23:31' prior: 0!
I represent a completion entry that is management by a ECModel and shown in the ECMenuMorph as a menu entry.!

NECEntry subclass: #NECClassVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECClassVarEntry commentStamp: '<historical>' prior: 0!
I represent a class Variable!

!NECClassVarEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ anECContext guessClassVarClass: contents! !

!NECClassVarEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'class variable'! !

!NECEntry class methodsFor: 'as yet unclassified' stamp: ''!
contents: aString type: aSymbol
	^ self new setContents: aString type: aSymbol! !

!NECEntry methodsFor: 'operations' stamp: ''!
<= aECEntry 
	^ contents <= aECEntry contents! !

!NECEntry methodsFor: 'operations' stamp: ''!
browseWith: anECContext 
	type := self guessTypeWith: anECContext.
	type ifNil: [^ false].
	SystemNavigation default browseClass: type.
	^ true! !

!NECEntry methodsFor: 'accessing' stamp: ''!
completion
	^ self contents asSymbol! !

!NECEntry methodsFor: 'accessing' stamp: ''!
contents
	^contents! !

!NECEntry methodsFor: 'accessing' stamp: ''!
contentsAsSymbol
	^ contents asSymbol ! !

!NECEntry methodsFor: 'detail information' stamp: ''!
createDescriptionWith: anECContext 
	| clazz |
	clazz := self guessTypeWith: anECContext.
	^ clazz 
		ifNil: [ NECEntryDescription label: self label ]
		ifNotNil: 
			[ NECEntryDescription 
				label: self label
				title: clazz printString
				description: clazz comment ]! !

!NECEntry methodsFor: 'operations' stamp: ''!
descriptionWith: anECContext 
	description ifNotNil: [ ^ description ].
	^ description := self createDescriptionWith: anECContext! !

!NECEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ nil! !

!NECEntry methodsFor: 'testing' stamp: ''!
isInstance
	^ false! !

!NECEntry methodsFor: 'testing' stamp: ''!
isLocal
	^ false! !

!NECEntry methodsFor: 'testing' stamp: ''!
isSelector
	^ false! !

!NECEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'unknown'! !

!NECEntry methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self class name;
		 nextPut: $(;
		 nextPutAll: contents;
		 nextPut: $,;
		 nextPutAll: type;
		 nextPut: $)! !

!NECEntry methodsFor: 'accessing' stamp: ''!
setContents: aString type: aSymbol 
	contents := aString.
	type := aSymbol! !

!NECEntry methodsFor: 'accessing' stamp: ''!
type
	^type! !

NECEntry subclass: #NECGlobalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECGlobalEntry commentStamp: '<historical>' prior: 0!
I represent a global variable.!

!NECGlobalEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	| globalEntry |
	globalEntry := Smalltalk at: contents ifAbsent: [^ nil].
	globalEntry isBehavior ifTrue: [^ globalEntry].
	globalEntry ifNotNil: [^ globalEntry class].
	^ nil! !

!NECGlobalEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'global'! !

NECEntry subclass: #NECInstVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECInstVarEntry commentStamp: '<historical>' prior: 0!
I represent an instance variable.!

!NECInstVarEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ anECContext guessInstVarClass: contents! !

!NECInstVarEntry methodsFor: 'testing' stamp: ''!
isInstance
^true! !

!NECInstVarEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'instance variable'! !

NECEntry subclass: #NECLocalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECLocalEntry commentStamp: '<historical>' prior: 0!
I represent a local variable!

!NECLocalEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ (anECContext guessTempVarClass: contents type: type) 
		ifNil: [anECContext guessArgument: contents]! !

!NECLocalEntry methodsFor: 'testing' stamp: ''!
isLocal
	^true! !

!NECLocalEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'local variable'! !

NECEntry subclass: #NECSelectorEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECSelectorEntry commentStamp: '<historical>' prior: 0!
I represent a selector!

!NECSelectorEntry methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 17:22'!
browseWith: anECContext
	^ self
		findMethodWith: anECContext
		do: [ :class :method | 
			Smalltalk tools browser 
				fullOnClass: class 
				selector: method selector. 
			true ]
		ifAbsent: [ :selector | 
			SystemNavigation default 
				browseAllImplementorsOf: selector.
			true ]! !

!NECSelectorEntry methodsFor: 'detail information' stamp: ''!
createDescriptionWith: anECContext 
	^ self
		findMethodWith: anECContext
		do: [:clazz :method | self
				methodSourceDescription: clazz
				method: method
				]
		ifAbsent: [:selector | self implementorsDescription: selector]! !

!NECSelectorEntry methodsFor: 'private' stamp: ''!
findMethodWith: anECContext do: foundBlock ifAbsent: notfoundBlock 
	| theClass result implementors |
	theClass := anECContext model theClass.
	result := theClass
				ifNil: [implementors := self systemNavigation allImplementorsOf: contents.
					implementors size == 1
						ifTrue: [| ref | 
							ref := implementors first.
							self lookupSelector: ref methodSymbol class: ref realClass]
						ifFalse: [^ notfoundBlock value: contents]]
				ifNotNil: [self lookupSelector: contents class: theClass]. 
	^ foundBlock value: result first value: result second! !

!NECSelectorEntry methodsFor: 'private' stamp: ''!
implementorsDescription: aSymbol 
	| implementors output |
	output := WriteStream on: String new.
	implementors := self systemNavigation allImplementorsOf: aSymbol.
	implementors isEmpty ifTrue: 
		[ ^ NECEntryDescription 
			label: 'symbol'
			title: '(no implementors)'
			description: 'This is just symbol.' ].
	implementors do: 
		[ :each | 
		output
			nextPutAll: each classSymbol printString;
			cr ].
	^ NECEntryDescription 
		label: self label
		title: '(Implementors)'
		description: output contents! !

!NECSelectorEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'method'! !

!NECSelectorEntry methodsFor: 'private' stamp: ''!
lookupSelector: aSymbol class: aClass 
	"Look up the given selector in my methodDictionary.
	Return the corresponding method if found.
	Otherwise chase the superclass chain and try again.
	Return nil if no method is found."
	| lookupClass |
	lookupClass := aClass.
	[lookupClass isNil]
		whileFalse: [(lookupClass includesSelector: aSymbol)
				ifTrue: [^ Array
						with: lookupClass
						with: (lookupClass compiledMethodAt: aSymbol)].
			lookupClass := lookupClass superclass].
	^ nil! !

!NECSelectorEntry methodsFor: 'as yet unclassified' stamp: ''!
methodSourceDescription: aClass method: aCompiledMethod 
	| styler |
	styler := SHTextStylerST80 new.
	styler classOrMetaClass: aClass.
	^ NECEntryDescription
		label: self label
		title: aClass printString
		description: (styler styledTextFor: (self methodSourceOn: aCompiledMethod ) asText)! !

!NECSelectorEntry methodsFor: 'private' stamp: ''!
methodSourceOn: aCompiledMethod 
	^ aCompiledMethod getSourceFor: aCompiledMethod selector
		in: aCompiledMethod methodClass! !

NECEntry subclass: #NECSelfEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECSelfEntry commentStamp: '<historical>' prior: 0!
I represent self!

!NECSelfEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ anECContext theClass! !

!NECSelfEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'self'! !

NECEntry subclass: #NECSuperEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECSuperEntry commentStamp: '<historical>' prior: 0!
I represent super.!

!NECSuperEntry methodsFor: 'operations' stamp: ''!
guessTypeWith: anECContext 
	^ anECContext theClass ifNotNil: [anECContext theClass superclass]! !

!NECSuperEntry methodsFor: 'accessing' stamp: ''!
label
	^ 'super'! !

Object subclass: #NECEntryDescription
	instanceVariableNames: 'title description label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECEntryDescription commentStamp: '<historical>' prior: 0!
A NECEntryDescription is a holder for some information to be displayed.!

!NECEntryDescription class methodsFor: 'instance creation' stamp: ''!
label: firstString 
	^ self new
		setLabel: firstString
		title: '(unknown)'
		description: nil! !

!NECEntryDescription class methodsFor: 'instance creation' stamp: ''!
label: firstString title: secondString description: thirdString 
	^ self new 
		setLabel: firstString
		title: secondString
		description: thirdString! !

!NECEntryDescription methodsFor: 'accessing' stamp: ''!
description
(	description isNil or:[description isEmpty]) ifTrue:[^'-'].
	^ description! !

!NECEntryDescription methodsFor: 'accessing' stamp: ''!
label
	^ label! !

!NECEntryDescription methodsFor: 'initialize-release' stamp: ''!
setLabel: firstString title: secondString description: thirdString 
	label := firstString.
	title := secondString.
	description := thirdString! !

!NECEntryDescription methodsFor: 'accessing' stamp: ''!
title
^ title! !

Object subclass: #NECModel
	instanceVariableNames: 'clazz selectors narrowString entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECModel commentStamp: '<historical>' prior: 0!
I'm an abstract class that stores the entries to be completed.!

!NECModel class methodsFor: 'instance creation' stamp: ''!
class: aClass 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance setClass: aClass.
	^ newInstance! !

!NECModel methodsFor: 'private' stamp: ''!
addToEntries: aCollection 
	| temp caseSensitive |
	caseSensitive := NECPreferences caseSensitive.
	temp := aCollection select: 
		[ :each | 
		each contents 
			occursInWithEmpty: narrowString
			caseSensitive: caseSensitive ].
	entries addAll: temp! !

!NECModel methodsFor: 'accessing' stamp: ''!
at: aNumber 
	^ entries at: aNumber ! !

!NECModel methodsFor: 'action' stamp: ''!
completionAt: aNumber
	^ (self at: aNumber) completion separateKeywords , ' '! !

!NECModel methodsFor: 'accessing' stamp: ''!
entries
	^entries! !

!NECModel methodsFor: 'accessing' stamp: ''!
entriesOfType: aSymbol 
	| collection |
	collection := entries select: [ :each | each type == aSymbol ].
	^ collection collect: [ :each | each contents ]! !

!NECModel methodsFor: 'accessing' stamp: ''!
entryCount
	^entries size! !

!NECModel methodsFor: 'accessing' stamp: ''!
hasMessage
	^ self message notNil! !

!NECModel methodsFor: 'initialize-release' stamp: ''!
initialize
	self reset! !

!NECModel methodsFor: 'accessing' stamp: ''!
initializeSelectors 
	self subclassResponsibility ! !

!NECModel methodsFor: 'testing' stamp: ''!
isEmpty
	^ entries isEmpty! !

!NECModel methodsFor: 'accessing' stamp: ''!
message
	^self isEmpty ifTrue: ['no completions found'] ifFalse: [nil]! !

!NECModel methodsFor: 'private' stamp: ''!
narrowString: aString 
	narrowString := aString! !

!NECModel methodsFor: 'action' stamp: ''!
narrowWith: aString
	self subclassResponsibility ! !

!NECModel methodsFor: 'testing' stamp: ''!
notEmpty 
	^self isEmpty not! !

!NECModel methodsFor: 'private' stamp: ''!
reset
	self resetSelectors.
	self resetEntries.
	narrowString := String new! !

!NECModel methodsFor: 'private' stamp: ''!
resetEntries
	entries := OrderedCollection new! !

!NECModel methodsFor: 'private' stamp: ''!
resetSelectors
	selectors := (SortedCollection new: 500) sortBlock: 
		[ :a :b | 
		| scoreA scoreB |
		scoreA := scoreB := 0.
		(a contents 
			beginsWithEmpty: narrowString
			caseSensitive: NECPreferences caseSensitive) ifFalse: [ scoreA := 2 ].
		(b contents 
			beginsWithEmpty: narrowString
			caseSensitive: NECPreferences caseSensitive) ifFalse: [ scoreB := 2 ].
		a contents < b contents
			ifTrue: [ scoreB := scoreB + 1 ]
			ifFalse: [ scoreA := scoreA + 1 ].
		scoreA < scoreB ]! !

!NECModel methodsFor: 'initialize-release' stamp: ''!
setClass: aClass 
	clazz := aClass.
	self initializeSelectors.
	self narrowWith: String new! !

!NECModel methodsFor: 'action' stamp: ''!
theClass
	^nil! !

!NECModel methodsFor: 'action' stamp: ''!
title
	^nil! !

!NECModel methodsFor: 'initialize-release' stamp: ''!
toggleExpand
	! !

NECModel subclass: #NECTypedModel
	instanceVariableNames: 'expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECTypedModel commentStamp: '<historical>' prior: 0!
I'm the model for a typed completion, that means when a receiver class is known. I only have selectors. I have an expand toggle: When false I filter out Object and ProtoObject selectors. The default value is true.!

NECTypedModel subclass: #NECOverrideModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECOverrideModel commentStamp: '<historical>' prior: 0!
I'm used when completing a method override. I contain all selectors of the superclass minus the already implemented selectors of the current class. When a completion occurs I complete a method template with a send to super.!

!NECOverrideModel methodsFor: 'action' stamp: ''!
completionAt: aNumber 
	| output source declaration |
	source := self methodSourceAt: aNumber.
	declaration := (source lineCorrespondingToIndex: 1) trimRight.
	output := WriteStream on: String new.
	output nextPutAll: declaration; cr; tab.
	(source includesSubString: 'subclassResponsibility') ifFalse: [
		(source includes: $^)
			ifTrue: [ output nextPutAll: '^ ' ].
		output
			nextPutAll: 'super ';
			nextPutAll: declaration ].
	^ output contents! !

!NECOverrideModel methodsFor: 'initialize-release' stamp: ''!
initializeSelectors
	self initializeSelectorsFor: clazz superclass.
	clazz methodDictionary keysDo: 
		[ :each | 
		| entry |
		entry := selectors 
			detect: [ :ea | ea contentsAsSymbol == each ]
			ifNone: [  ].
		entry notNil ifTrue: 
			[ selectors 
				remove: entry
				ifAbsent: [  ] ] ]! !

!NECOverrideModel methodsFor: 'private' stamp: ''!
methodAt: aNumber 
	^ clazz lookupSelector: (self at: aNumber) contentsAsSymbol! !

!NECOverrideModel methodsFor: 'private' stamp: ''!
methodSourceAt: aNumber 
	^ (self methodAt: aNumber) getSourceFromFile asString! !

!NECOverrideModel methodsFor: 'action' stamp: ''!
title
	^ '(override) ' , clazz superclass name! !

!NECTypedModel methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	expanded := true! !

!NECTypedModel methodsFor: 'private' stamp: ''!
initializeSelectors
	self initializeSelectorsFor: clazz! !

!NECTypedModel methodsFor: 'private' stamp: ''!
initializeSelectorsFor: aClass 
	|excludedClasses|
	selectors reset.
	excludedClasses := (expanded ifTrue: [#()] ifFalse: [Object withAllSuperclasses]).
	selectors addAll: ((aClass allSelectorsWithout: excludedClasses)
						collect: [:each | NECSelectorEntry contents: each type: #selector])! !

!NECTypedModel methodsFor: 'action' stamp: ''!
narrowWith: aString 
	self
		narrowString: aString ;
		initializeSelectors.
	entries reset.
	self addToEntries: selectors! !

!NECTypedModel methodsFor: 'action' stamp: ''!
theClass
	^clazz! !

!NECTypedModel methodsFor: 'action' stamp: ''!
title
	^clazz name! !

!NECTypedModel methodsFor: 'action' stamp: ''!
toggleExpand
	expanded := expanded not.
	self initializeSelectors.
	self narrowWith: narrowString! !

NECModel subclass: #NECUntypedModel
	instanceVariableNames: 'instVars localVars includeVariables includeSelectors classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECUntypedModel commentStamp: '<historical>' prior: 0!
When no receiver class is known, I'm the right model. I store all temporary variables, instance variables of the selected class and all selectors in system. For performance reasons I only collect selectors when at least one character is known.!

NECUntypedModel subclass: #NECUnseparatedModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECUnseparatedModel commentStamp: '<historical>' prior: 0!
kind of variant but no idea why - sd!

!NECUnseparatedModel methodsFor: 'action' stamp: ''!
completionAt: aNumber 
	^ (self at: aNumber) completion! !

!NECUntypedModel class methodsFor: 'instance creation' stamp: ''!
class: aClass temporaries: aCollection 
	^self 
		class: aClass
		temporaries: aCollection
		additionals: #()
		variables: true
		selectors: true! !

!NECUntypedModel class methodsFor: 'instance creation' stamp: ''!
class: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance 
		setClass: aClass
		temporaries: aCollection
		additionals: additionalCollection
		variables: variablesBoolean
		selectors: selectorsBoolean.
	^ newInstance! !

!NECUntypedModel methodsFor: 'private' stamp: ''!
addAdditionals: aCollection 
	aCollection
		ifNotNil: [aCollection
				do: [:each | each isLocal
						ifTrue: [localVars add: each value]
						ifFalse: [each isInstance
								ifTrue: [instVars add: each value]
								ifFalse: [each isSelector
										ifTrue: [selectors add: each value]]]]]! !

!NECUntypedModel methodsFor: 'private' stamp: ''!
addSelectors
	self initializeSelectors.
	self addToEntries: selectors! !

!NECUntypedModel methodsFor: 'private' stamp: ''!
addVariables
	includeVariables
		ifFalse: [^ self].
	self addToEntries: localVars.
	self addToEntries: instVars.
	self addToEntries: classVars! !

!NECUntypedModel methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	localVars := SortedCollection new.
	instVars := SortedCollection new.
	classVars := SortedCollection new.
	includeSelectors := true.
	includeVariables := true! !

!NECUntypedModel methodsFor: 'initialize-release' stamp: ''!
initializeClassVars
	(clazz isNil or: [ includeVariables not ]) ifTrue: [ ^ self ].
	classVars := clazz theNonMetaClass allClassVarNames asSortedCollection.
	classVars := classVars collect: 
		[ :each | 
		NECClassVarEntry 
			contents: each
			type: #classVar ]! !

!NECUntypedModel methodsFor: 'initialize-release' stamp: ''!
initializeInstVars
	(clazz isNil or: [ includeVariables not ]) ifTrue: [ ^ self ].
	instVars := clazz allInstVarNames asSortedCollection.
	instVars := instVars collect: 
		[ :each | 
		NECInstVarEntry 
			contents: each
			type: #instVar ].
	instVars add: (NECSelfEntry 
			contents: 'self'
			type: #self).
	instVars add: (NECSuperEntry 
			contents: 'super'
			type: #super)! !

!NECUntypedModel methodsFor: 'private' stamp: ''!
initializeSelectors
	self resetSelectors.
	includeSelectors ifFalse: 
		[ Smalltalk keysAndValuesDo: [ :each :class |
			selectors add: (NECGlobalEntry 
					contents: each
					type: #globalVar) ].
		^ self ].
	narrowString ifEmpty: [ ^ self ].
	NECSymbols 
		contains: narrowString
		caseSensitive: NECPreferences caseSensitive
		do: 
			[ :each | 
			(includeVariables or: [ each first isLowercase ]) ifTrue: 
				[ selectors add: (NECSelectorEntry 
						contents: each
						type: #selector).
				selectors size > 500 ifTrue: [ ^ self ] ] ]! !

!NECUntypedModel methodsFor: 'accessing' stamp: ''!
message
	^ (includeSelectors and: [ narrowString isEmpty ]) 
		ifTrue: 
			[ selectors size = 500 
				ifTrue: [ 'more...' ]
				ifFalse: [ 'press key for selectors' ] ]
		ifFalse: [ super message ]! !

!NECUntypedModel methodsFor: 'initialize-release' stamp: ''!
narrowString: aString 
	(narrowString isEmpty
			or: [aString isEmpty
			or: [aString first ~= narrowString first]])
		ifTrue: [self reset].
	super narrowString: aString! !

!NECUntypedModel methodsFor: 'action' stamp: ''!
narrowWith: aString 
	self narrowString: aString.
	self resetEntries.
	self addVariables.
	self addSelectors! !

!NECUntypedModel methodsFor: 'initialize-release' stamp: ''!
setClass: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	includeVariables := variablesBoolean.
	includeSelectors := selectorsBoolean.
	clazz := aClass.
	self initializeInstVars.
	self initializeClassVars.
	includeVariables 
		ifTrue: 
			[ localVars := aCollection.
			self addAdditionals: additionalCollection ]
		ifFalse: [ localVars := OrderedCollection new ].
	self
		resetEntries;
		addVariables;
		addSelectors! !

Object subclass: #NECPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Pharo'!

NECPreferences class
	instanceVariableNames: 'enabled caseSensitive smartCharacters smartCharactersMapping backgroundColor'!

NECPreferences class
	instanceVariableNames: 'enabled caseSensitive smartCharacters smartCharactersMapping backgroundColor'!

!NECPreferences class methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 13:04'!
availableControllers
	^NECController withAllSubclasses copyWithout: NECWorkspaceController! !

!NECPreferences class methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 13:38'!
backgroundColor 
	^backgroundColor ifNil: [ 
		backgroundColor := (UITheme current settings menuColor ifNil: [ Color white ]) ]! !

!NECPreferences class methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 13:36'!
backgroundColor: aColor 
	backgroundColor := aColor! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
caseSensitive
	^ caseSensitive
! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
caseSensitive: aBoolean
	caseSensitive := aBoolean! !

!NECPreferences class methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 13:10'!
currentController 
	^ (Smalltalk tools hasToolNamed: #codeCompletion)
		ifTrue: [ Smalltalk tools codeCompletion ]
		ifFalse: [ nil ]! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
enabled
	^ enabled
! !

!NECPreferences class methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 13:11'!
enabled: aBoolean
	enabled := aBoolean.! !

!NECPreferences class methodsFor: 'initialization' stamp: 'EstebanLorenzano 4/12/2012 13:43'!
initialize
	enabled := caseSensitive := smartCharacters := true.
	smartCharactersMapping := Dictionary new.
	smartCharactersMapping
		at: $( put: $);
		at: $[ put: $];
		at: ${ put: $};
		at: $" put: $";
		at: $' put: $'.! !

!NECPreferences class methodsFor: 'settings' stamp: 'EstebanLorenzano 4/12/2012 13:39'!
settingsOn: aBuilder 
	<systemsettings>

	(aBuilder setting: #'Code Completion') 
		target: self; 
		parentName: #codeBrowsing;
		selector: #enabled;
		icon: UITheme current smallConfigurationIcon;
		description: 'Enable or disable code completion in browsers, debuggers and workspaces.';
		with: [
			| availableControllers |
			availableControllers := self availableControllers.
			availableControllers size > 1
				ifTrue: [
					(aBuilder pickOne: #completionController)
						order: -1;
						label: 'Controller' translated;
						getSelector: #currentController;
						setSelector: #useController:;
						domainValues: availableControllers ].
			(aBuilder setting: #backgroundColor)
				target: self;
				label: 'Background Color' translated.		
			(aBuilder setting: #caseSensitive) 
				label: 'Case Sensitive';
		 		description: 'Decide if you want eCompletion to be case sensitive or not.'.
			(aBuilder setting: #smartCharacters) 
				label: 'Smart Characters';
		 		description: 'Decide if you want eCompletion to use smart characters, e.g, to automatically close brackets.' ]! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
smartCharacters
	^ smartCharacters! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
smartCharacters: aBoolean
	smartCharacters := aBoolean! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
smartCharactersMapping
	^ smartCharactersMapping! !

!NECPreferences class methodsFor: 'accessing' stamp: ''!
smartCharactersMapping: aDictionary
	smartCharactersMapping := aDictionary! !

!NECPreferences class methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 11:24'!
useController: aClass
	aClass registerToolsOn: Smalltalk tools! !

Object subclass: #NECReadMe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECReadMe commentStamp: '<historical>' prior: 0!
NEC is based on the eCompletion package developed by Ruben Baker. We thank Ruben for having release this code in MIT. It was maintained by lukas renggli, damien Cassou and a couple of other cool developers.

The current version (NEC) relies on some methods that re available in Pharo1.4. In addition the extensions made to shout has been moved to the Shout package.

The goal of thise new version is to make sure that OCompletion can be just expressed as an extension of ECompletion and not a full copy of the ecompletion.

This package relies on Shout.!

Object subclass: #NECSymbols
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Pharo'!

!NECSymbols class methodsFor: 'as yet unclassified' stamp: ''!
contains: aString caseSensitive: aBoolean do: aBlock 
	Symbol allSymbolTablesDo: [ :each | 
		((each includes: $ ) not and: [ each includesSubstring: aString caseSensitive: aBoolean ]) 
			ifTrue: [ aBlock value: each ] ]! !

!NECSymbols class methodsFor: 'as yet unclassified' stamp: ''!
startsWith: aChar caseSensitive: aBoolean do: aBlock 
	| char caseInSensitive firstChar |
	caseInSensitive := aBoolean not.
	firstChar := caseInSensitive 
		ifTrue: [ aChar asLowercase ]
		ifFalse: [ aChar ].
	Symbol allSymbolTablesDo: 
		[ :each | 
		| size |
		size := each size.
		char := size > 0 ifTrue: [ each first ].
		(char notNil 
			and: [ (char == firstChar or: [ caseInSensitive and: [ char asLowercase == firstChar ] ])
			and: [ (each 
				findAnySubStr: '- '
				startingAt: 2) > size ] ]) ifTrue: [ aBlock value: each ] ]! !

Object subclass: #NECTestSuperClass
	instanceVariableNames: 'superInstVar'
	classVariableNames: 'SuperClassVar'
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECTestSuperClass commentStamp: '<historical>' prior: 0!
I'm only for SUnit TestCases.!

NECTestSuperClass subclass: #NECTestClass
	instanceVariableNames: 'third fourth typeSuggestingParameter messageSend messageSend2 typeSuggestingParameter2 complexInit complexInit2 constantInteger constantSymbol constantArray constantBoolean constantString constantNil globalVarKeyword globalVarKeyword2'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'NECompletion-Tests'!

!NECTestClass commentStamp: '<historical>' prior: 0!
I'm only for SUnit TestCases.!

!NECTestClass class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	ClassVar := 'Any string'! !

!NECTestClass methodsFor: 'utils' stamp: ''!
initialize: aRectangle 
	constantInteger := 15.
	constantString := 'Ruben'.
	constantSymbol := #Symbol.
	constantArray := #(15 16 17 28 ).
	constantBoolean := true.
	typeSuggestingParameter := aRectangle.
	messageSend := Dictionary new.
	messageSend2 := aRectangle origin.
	globalVarKeyword := SortedCollection
				sortBlock: [:a :b | a <= b].
	globalVarKeyword2 := SortedCollection new: 15.
	constantNil := nil.
	typeSuggestingParameter2 := nil.
	complexInit := 15 > 16
				ifTrue: [#Symbol]
				ifFalse: ['String'].
	complexInit2 := Dictionary new: aRectangle origin x. ! !

!NECTestClass methodsFor: 'utils' stamp: ''!
lowPriorityOverrides: aRectangle 
	messageSend := aRectangle.
	typeSuggestingParameter2 := aRectangle. ! !

!NECTestClass methodsFor: 'tests' stamp: ''!
testIt: anArgument 
	| loc1 x2 t |
	x2 := [:bar :var | var < bar].
	loc1 := constantArray.
	x2 value: loc1.
	t := 15.
	^ x2! !

!NECTestSuperClass class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	SuperClassVar := Dictionary new! !

!NECTestSuperClass methodsFor: 'initialize-release' stamp: ''!
initialize
	superInstVar := Dictionary new! !

!NECTestSuperClass methodsFor: 'tests' stamp: ''!
testIt: aString
	self subclassResponsibility ! !

!NECTestSuperClass methodsFor: 'utils' stamp: ''!
toBeOverriden: anArgument 
	15 > 16
		ifTrue: [self sample * anArgument ]! !

!NECTestSuperClass methodsFor: 'utils' stamp: ''!
toBeOverridenWithReturn
	^ 'saga'! !

Object subclass: #NECTypeInfo
	instanceVariableNames: 'type kind temporaryOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NECompletion-Model'!

!NECTypeInfo commentStamp: '<historical>' prior: 0!
I'm used in ECInstVarTypeGuesser to store found type informations.!

!NECTypeInfo class methodsFor: 'as yet unclassified' stamp: ''!
definedByLiteral: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 1.
	^ newInstance! !

!NECTypeInfo class methodsFor: 'as yet unclassified' stamp: ''!
definedByMessageSend: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 2.
	^ newInstance! !

!NECTypeInfo class methodsFor: 'as yet unclassified' stamp: ''!
definedByTemporaryVar: anInteger
	| newInstance |
	newInstance := self new.
	newInstance setType: nil kind: 3.
	newInstance temporaryOffset: anInteger.
	^ newInstance! !

!NECTypeInfo methodsFor: 'testing' stamp: ''!
isDefinedByMessageSend
	^kind == 2! !

!NECTypeInfo methodsFor: 'testing' stamp: ''!
isDefinedByTemporary
	^ kind == 3! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
priority
	^kind! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
setType: aClass kind: anInteger 
	type := aClass.
	kind := anInteger! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
temporaryOffset
	^temporaryOffset! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
temporaryOffset: anInteger 
	temporaryOffset := anInteger! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
type
	^type! !

!NECTypeInfo methodsFor: 'accessing' stamp: ''!
type: aClass 
	type := aClass! !

!Object methodsFor: '*necompletion-extensions' stamp: 'EstebanLorenzano 4/11/2012 15:47'!
isCodeCompletionAllowed
	^false! !
NECController initialize!
NECPreferences initialize!
NECTestSuperClass initialize!
NECTestClass initialize!
